angular.module('starter.controllers', [])


.controller('AppCtrl', function($scope, $rootScope, $state, $ionicModal, $ionicPopup, Loading, Usuario) {
	//$rootScope.usuario = {};
	//Usuario.openLogin();
})

.controller('AsuetosCtrl', function($scope, Asuetos, $ionicModal, Loading, $ionicPopup){
	$scope.$on('$ionicView.enter', function() {
		$scope.asuetos = {};
		$scope.asueto = {};
		$scope.delete = "";
		$scope.title = "";
		$scope.loadPage();
	});

	$scope.loadPage= function(){
		Asuetos.get().then(function(d){
			console.log(d.data);
			$scope.asuetos = d.data;
		});
	}

	$ionicModal.fromTemplateUrl('templates/nuevoAsueto.html', {
		scope: $scope,
		backdropClickToClose: false,
		hardwareBackButtonClose: false,
	}).then(function(modal) {
		$scope.nuevoAsuetoModal = modal;
	});

	$scope.closeAsuetoModal = function(){
		$scope.asueto = {};
		$scope.nuevoAsuetoModal.hide();
	};
	$scope.newAsueto = function(asueto){
		if(asueto){
			$scope.title = "Actualizar"	
			$scope.asueto = asueto; 
		}else{
			$scope.title = "Nuevo"	
		}
		$scope.nuevoAsuetoModal.show();
	};
	$scope.sendAsueto = function(){
		Loading.show();
		if($scope.title == "Actualizar"){
			Asuetos.update($scope.asueto).then(function(data){
				Loading.hide();
				if('data' in data){				
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Día de asueto actualizado'
					});
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			});
		}else if($scope.title == "Nuevo" ){ 
			Asuetos.new($scope.asueto).then(function(data){
				Loading.hide();
				if('data' in data){				
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Día de asueto guardado'
					});
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			});
		}
	};
	$scope.deleteAsueto = function(d){
		$scope.delete = d;
		$ionicPopup.confirm({
			title: '¿Desea eliminar este día de asueto?',
			template: '<div></div>'
		}).then(function(res) {
			if(res){
				console.log($scope.delete);
				Asuetos.delete($scope.delete).then(function(data){
					if('data' in data){				
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Listo!',
							template: 'Día de asueto eliminado'
						}).then(location.reload());
					}else{
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
						});
					}
				})
			}else{
				console.log(res);
			}
		});
	}
})

.controller('MenuCtrl', function($scope, $state, AuthService){
//	$scope.user = Usuario.level();
	$scope.AuthService = function(p){
		return AuthService.isAuthorized(p);
	}

	$scope.closeSesion = function(){
		localStorage.clear();
		//Usuario.openLogin();
		$state.go('app.login');	
	};
})

.controller('LoginCtrl', function($scope, $state, $ionicPopup, Loading, Usuario, AuthService) {
	$scope.$on('$ionicView.enter', function() {
		$scope.usuario = {};
	});
	//Usuario.openLogin();
	$scope.doLogin = function(user) {
		localStorage.setItem('enviroment', user.enviroment);
		Loading.show();
		AuthService.login(user).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR' && 'token' in data.data){
				localStorage.setItem('token', data.data.token);
				$state.go('app.canjearVale');
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});	
	};
})

.controller('ReportesCtrl', function($scope, $rootScope, $ionicPopup, $state, $window, $filter, ApiEndpoint){
	//$window.open('/api/distribuidores/recibo/'+data.data.pago_id+'/1','_NEW');
	$scope.$on('$ionicView.enter', function() {
		$scope.api_url = ApiEndpoint.url;
		$rootScope.fechas = {};
		$scope.enviroment = localStorage.enviroment;
		$scope.public = localStorage.public;
		$scope.loadPage();
	});

	$scope.loadPage= function(){
		$scope.reporteFechas = function(e) {
			var tmplt = 	'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="fechas.fecha1" placeholder="Fecha"></label>'+
							'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="fechas.fecha2" placeholder="Fecha"></label>';
			console.log("modal");
			$ionicPopup.confirm({
				title: 'Definir Fechas',
				template:	tmplt
			}).then(function(res) {
				if(res){
					// debugger
					console.log($scope.fechas);
					$window.open(ApiEndpoint.url + 'reportes/'+e+'/'+$filter('date')($rootScope.fechas.fecha1, "yyyy-MM-dd")+'/'+$filter('date')($rootScope.fechas.fecha2, "yyyy-MM-dd")+'/?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
				}else{
					console.log($scope.fechas);
				}
			});
		};

		$scope.reporteFechasID = function(e) {
			var tmplt = 	'<label class="item item-input"><i class="icon ion-user placeholder-icon"></i><input type="number" ng-model="data.id" placeholder="ID"></label>' +
							'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="fechas.fecha1" placeholder="Fecha"></label>'+
							'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="fechas.fecha2" placeholder="Fecha"></label>'+
							'<input type="checkbox" ng-model="data.liquidados" name="liquidados"><label for="liquidados">Liquidaciones Adelantadas</label>';
			console.log("modal");
			$rootScope.data = {
				id: 0,
				liquidados: false
			}
			$ionicPopup.confirm({
				title: 'Definir Fechas',
				template:	tmplt
			}).then(function(res) {
				if(res){
					console.log($scope.fechas);
					$window.open(ApiEndpoint.url + 'reportes/'+e+'/'+$rootScope.data.id+'/'+$filter('date')($rootScope.fechas.fecha1, "yyyy-MM-dd")+'/'+$filter('date')($rootScope.fechas.fecha2, "yyyy-MM-dd")+'/?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public+($rootScope.data.liquidados ? '&liquidacion_temprana' : ''),'_NEW');
				}else{
					console.log($scope.fechas);
				}
			});
		};

		$scope.reporteFechaIDStatus = function(e) {
			var tmplt = 	
							'<label class="item item-input"><select ng-model="data.rol">' +
							'<option value="ALL">Todos</option>' +
							'<option value="ACTIVO">Activos</option>' +
							'<option value="MOROSO">Moroso</option>' +
							'</select></label>' +
							'<label class="item item-input"><i class="icon ion-user placeholder-icon"></i><input type="number" ng-model="data.id" placeholder="ID"></label>' +
							'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="fechas.fecha" placeholder="Fecha"></label>';
			console.log("modal");
			$rootScope.data = {
				id: 0
			}
			$ionicPopup.confirm({
				title: 'Definir Fechas',
				template:	tmplt
			}).then(function(res) {
				if(res){
					console.log($scope.fechas);
					$window.open(ApiEndpoint.url + 'reportes/'+e+'/'+$rootScope.data.rol+'/'+$rootScope.data.id+'/'+$filter('date')($rootScope.fechas.fecha, "yyyy-MM-dd")+'/?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
				}else{
					console.log($scope.fechas);
				}
			});
		};

		$scope.reporteFechasIDStatus = function(e) {
			var tmplt = 	
							'<label class="item item-input"><select ng-model="data.rol">' +
							'<option value="ALL">Todos</option>' +
							'<option value="ACTIVO">Activos</option>' +
							'<option value="MOROSO">Moroso</option>' +
							'</select></label>' +
							'<label class="item item-input"><i class="icon ion-user placeholder-icon"></i><input type="number" ng-model="data.id" placeholder="ID"></label>' +
							'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="fechas.fecha" placeholder="Fecha"></label>' +
							'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="fechas.fecha2" placeholder="Fecha"></label>';
			console.log("modal");
			$rootScope.data = {
				id: 0
			}
			$ionicPopup.confirm({
				title: 'Definir Fechas',
				template:	tmplt
			}).then(function(res) {
				if(res){
					console.log($scope.fechas);
					$window.open(ApiEndpoint.url + 'reportes/'+e+'/'+$rootScope.data.rol+'/'+$rootScope.data.id+'/'+$filter('date')($rootScope.fechas.fecha, "yyyy-MM-dd")+'/'+$filter('date')($rootScope.fechas.fecha2, "yyyy-MM-dd")+'/?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
				}else{
					console.log($scope.fechas);
				}
			});
		};

		$scope.reporteCumpleanos = function(e) {
			var tmplt = 	'<label class="item item-input"><i class="icon ion-user placeholder-icon"></i><select ng-model="cumpleanos.target"><option value="distribuidores">Distribuidores</option><option value="clientes">Clientes</option></select></label>' +
							'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="cumpleanos.fecha1" placeholder="Fecha"></label>'+
							'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="cumpleanos.fecha2" placeholder="Fecha"></label>';
			console.log("modal");
			$rootScope.cumpleanos = {
				target: '',
				fecha1: new Date(),
				fecha2: new Date()
			}
			$ionicPopup.confirm({
				title: 'Definir Parámetro para cumpleaños',
				template:	tmplt
			}).then(function(res) {
				if(res){
					console.log($scope.fechas);
					$window.open(ApiEndpoint.url + 'reportes/cumpleanos/'+$rootScope.cumpleanos.target+'/'+$filter('date')($rootScope.cumpleanos.fecha1, "yyyy-MM-dd")+'/'+$filter('date')($rootScope.cumpleanos.fecha2, "yyyy-MM-dd")+'/'+e+'?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
				}else{
					console.log($scope.fechas);
				}
			});
		};

		$scope.reporteFecha = function(e,t) {
			$rootScope.data = {
				fecha: new Date(),
				id: 0
			};

			$ionicPopup.confirm({
				title: 'Definir Datos',
				template:	'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="data.fecha" placeholder="Fecha"></label>'+
				'<label class="item item-input"><i class="icon ion-user placeholder-icon"></i><input type="number" ng-model="data.id" placeholder="ID"></label>'
			}).then(function(res) {
				if(res){
					console.log($rootScope.data);
					$window.open(ApiEndpoint.url + 'reportes/'+e+'/'+$rootScope.data.id+'/'+$filter('date')($rootScope.data.fecha, "yyyy-MM-dd")+'/?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
				}else{
					console.log($rootScope.data);
				}
			});
		};
	}
})

.controller('ReporteCtrl', function($scope, Reportes){
	$scope.$on('$ionicView.enter', function() {
		$scope.loadPage();
	});
	$scope.loadPage= function(){
		Reportes.get().then(function(d){
			console.log(d.data);
			$scope.reporte = d.data;
		});
	}
		
})

.controller('StatsCtrl', function($scope, $state, Loading, Stats) {
	$scope.$on('$ionicView.enter', function() {
		Loading.show();

		Stats.actual().then(function(data){
			Loading.hide();
			$scope.actual = data.data;
		});

		Stats.pendiente().then(function(data){
			Loading.hide();
			$scope.pendiente = data.data;
		});

		Stats.vencidos().then(function(data){
			Loading.hide();
			$scope.vencidos = data.data;
		});

		Stats.proyectados().then(function(data){
			Loading.hide();
			$scope.proyectados = data.data;
		});

		$scope.viewContrato = function(vencido){
			vencido.rol == 'DISTRIBUIDOR' ? $state.go('app.statsDistribuidor', { 'DistribuidorId': vencido.distribuidor_id }) :	$state.go('app.contrato', { 'ContratoId': vencido.contrato });
		};

		$scope.viewCliente = function(id){
			$state.go('app.cliente', { 'ClienteId': id});
		};
	});
})

.controller('CajaCtrl', function($scope, $state, $q, $filter, $window, $ionicPopup, Loading, Stats, $ionicModal, Vales, Distribuidor) {
	$scope.$on('$ionicView.enter', function() {
		$scope.ready = true;
		$scope.loadCaja('ACTIVO');
	});

	$scope.loadCaja = function(estado) {
		Loading.show();
		$scope.por_pagar = null;

		$scope.estado = estado;

		Stats.caja($scope.estado).then(function(data){
			Loading.hide();
			$scope.vencidos = data.data;
		});
	};

	$ionicModal.fromTemplateUrl('templates/pagar.html', {
		scope: $scope,
		backdropClickToClose: false,
		hardwareBackButtonClose: false,
	}).then(function(modal) {
		$scope.modal = modal;
		//$scope.modal.show();
	});

	$scope.openPago = function(c){
		Loading.show();
		c.id = c.distribuidor_id;
		c.target = 'distribuidor';
		Vales.due(c).then(function(d){
			$scope.pagos = d.data;
			$scope.por_pagar = c;
			$scope.pago = {
				"restante" : ($scope.pagos.pago.capital + $scope.pagos.pago.intereses)*(1-parseFloat($scope.pagos.pago.comision)*0.01) + $scope.pagos.pago.intereses_moratorios - parseFloat($scope.pagos.pago.saldo_afavor) + $scope.pagos.pago.seguro,
				"afavor" : 0
			}
			$scope.pago_realizado = {
				"distribuidor_id" : c.distribuidor_id,
				"producto_id" : c.producto_id,
				"comision" : parseFloat($scope.pagos.pago.comision),
				"monto" : 0,
				"condonado" : 0,
				"dias_vencidos": c.dias_vencidos,
				"fecha_programada" : c.fecha_programada,
				"fecha_realizada" : new Date()
			};
			$scope.modal.show();
			Loading.hide();
		});
	};

	$scope.closePago = function() {
		$scope.modal.hide();
	};

	$scope.canjearVale = function(){
		$state.go('app.canjearVale');
	};

	/*CONTRATO*/
	$scope.calcSaldo = function(){
		$scope.contrato.precio_total = parseFloat($scope.contrato.precio_acordado) - parseFloat($scope.contrato.enganche);
	};

	$scope.calcPago = function(){
		console.log($scope.contrato.pago);
		$scope.contrato.pago = Credito.pago($scope.contrato.precio_total, parseFloat($scope.contrato.interes)/360*parseInt($scope.contrato.periodo_entre_pagos), parseInt($scope.contrato.periodos));
		$scope.contrato.saldo_insoluto = $scope.contrato.pago*parseInt($scope.contrato.periodos);
	};

	/*PAGAR ANTERIORES*/
	$scope.get_moratorios = function(pago){
		pago.dias_vencidos = $scope.get_dias(pago);
		pago.intereses_moratorios = parseFloat(pago.capital_real)*pago.dias_vencidos*parseFloat(pago.interes_moratorio)/360;

		return pago;
	};

	$scope.check_fecha = function(f){
		return typeof f !== 'object';
	};

	$scope.get_dias = function(p){
		var date1 = new Date(p.fecha_programada);
		var date2 = new Date(p.fecha_realizada);
		var timeDiff = Math.abs(date2.getTime() - date1.getTime());
		var diffDays = Math.floor(timeDiff / (1000 * 3600 * 24)); 
		return diffDays;
	};

	$scope.get_total = function(p){
		return parseFloat(p.capital_real)+parseFloat(p.interes_real);
	};

	$scope.get_condonado = function(p){
		var abono = p.monto;
		var restante = parseFloat(p.capital_real)+parseFloat(p.interes_real)+parseFloat(p.intereses_moratorios)+parseFloat(p.seguro);
		return restante > abono ? restante-abono : 0;
	};

	/*CAJA*/
})

.controller('ModalCajaCtrl', function($scope, $q, $filter, $window, Loading, $ionicPopup, $ionicModal, Contrato, Distribuidor, Vales, AuthService, Credito, $stateParams){
	$scope.$on('$ionicView.enter', function() {
		$scope.enviroment = localStorage.enviroment;
		$scope.public = localStorage.public;
	});
	
	$scope.get_pagoParaLiquidar = function(pagos){
		if(pagos === undefined || !('pago' in pagos)) return;
		try {
			pagos.pago.capital_vencido = pagos.pago.capital_vencido === undefined ? 0 : pagos.pago.capital_vencido;
			if( (pagos.pago.capital_vencido+pagos.pago.intereses)*(1-($scope.pago_realizado.comision*0.01))+pagos.pago.intereses_moratorios+parseFloat(pagos.pago.seguro) == 0 ){ $scope.pagado = 'balanced-bg'; } else { $scope.pagado = ''; }
			if(typeof pagos !== 'undefined') return parseFloat(pagos.saldo_insoluto)+(pagos.pago.capital_vencido+pagos.pago.intereses)*(1-($scope.pago_realizado.comision*0.01))+pagos.pago.intereses_moratorios-pagos.pago.saldo_afavor+parseFloat(pagos.pago.seguro);
		} catch (e) {
			console.log(e);
		}
	}

	$scope.reestructurar = function(por_pagar, pagos){
		$scope.contrato = {
			saldo_insoluto: pagos.pago.saldo_insoluto,
			intereses: 0,
			interes_moratorio: 0
		}

		for(pago in pagos.detalle){
			$scope.contrato.intereses += parseFloat(pagos.detalle[pago].intereses_vencidos);
			$scope.contrato.interes_moratorio += parseFloat(pagos.detalle[pago].intereses_moratorios_vencidos);
		}

		$scope.get_intereses = function(){
			let intereses = {
				normales: $scope.contrato.intereses,
				moratorios: $scope.contrato.interes_moratorio
			};
	
			return intereses;
		};

		$scope.nuevo_pago = function(){
			if($scope.reestructuracion !== undefined){
				return Credito.pago($scope.reestructuracion.precio_acordado, parseFloat($scope.reestructuracion.interes)*0.01/360*parseInt($scope.reestructuracion.periodo_entre_pagos), parseInt($scope.reestructuracion.periodos));
			}else{
				return 0;
			}
		};

		$scope.doRestructura = function(r){
			Distribuidor.restructure(r).then(function(data){
				if('data' in data){
					//$scope.contrato = data;		
					Loading.hide();
					$state.go('app.contrato', { 'ContratoId': data.contrato_id });
				}else{
					Loading.hide();
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
	
					});
				}
			});
		};
		
		$ionicModal.fromTemplateUrl('templates/restructura.html', {
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.reestructuracion = {
				distribuidor_id: $scope.por_pagar.distribuidor_id,
				saldo_afavor: pagos.pago.saldo_afavor,
				precio_acordado: 0,
				periodos: 0,
				interes: 0,
				periodo_entre_pagos: 0,
				numero_pagos: 0
			};
			$scope.restructure = modal;
			$scope.restructure.show();
		});
	};

	$scope.closeRestructuracion = function() {
		$scope.restructure.hide();
	};

	$scope.AuthService = function(p){
		return AuthService.isAuthorized(p);
	}
	
	$scope.calcTotal = function(pago){
		return parseFloat(pago.capital_real)+parseFloat(pago.interes_real)+parseFloat(pago.intereses_moratorios)+parseFloat(pago.seguro);
	};

	$scope.calcPagado = function(pago){
		capital_restante = pago.capital_restante === null ? pago.capital : pago.capital_restante;
		intereses_restante = pago.intereses_restante === null ? pago.interes_real : pago.intereses_restante;
		return parseFloat(pago.capital)+parseFloat(pago.interes_real)-parseFloat(capital_restante)-parseFloat(intereses_restante);
	};

	$scope.get_fechaCorte = function(fecha){
		const diaFecha = $filter('date')(fecha, "dd")
		let dia
		if( diaFecha < 21 && diaFecha > 3 )
		{
			dia = $filter('date')(fecha, "MM") + '-06'
		}else if (diaFecha >= 15) {
			dia = $filter('date')(fecha, "MM") + '-21'
		}else{
			let mes = parseInt($filter('date')(fecha, "MM"))
			if(mes < 12 && mes < 10){
				dia =  '0' + ( $filter('date')(fecha, "MM") - 1 ) + '-21'
			}else if(mes < 12){
				dia =  $filter('date')(fecha, "MM")- 1 + '-21'
			}else{
				dia = '01-21'
			}

		}
		return $filter('date')(fecha, "yyyy-") + dia;
	};
	
	$scope.printCorte = function(distribuidor, fecha){
		$window.open('https://api.avanzamas.net/distribuidor/'+distribuidor+'/corte/'+fecha+'/1?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
	};

	$scope.sum_totales = function(){
		$scope.pagos.pago.capital				= 0;
		$scope.pagos.pago.intereses				= 0;
		$scope.pagos.pago.intereses_moratorios	= 0;

		$scope.pago_realizado.monto				= 0;
		$scope.pago_realizado.condonado 		= 0;

		for(p in $scope.pagos.detalle){	
			// if($scope.pagos.detalle[p].fecha_realizada !== null){
				if(p > 0 && $scope.pagos.detalle[p].fecha_realizada.getTime() > $scope.pagos.detalle[p-1].fecha_realizada.getTime()){
					$scope.pagos.detalle[p].fecha_realizada = $scope.pagos.detalle[p-1].fecha_realizada;
				}

				$scope.pagos.pago.capital				+= parseFloat($scope.pagos.detalle[p].capital_real);
				$scope.pagos.pago.intereses				+= parseFloat($scope.pagos.detalle[p].interes_real);
				$scope.pagos.pago.intereses_moratorios	+= parseFloat($scope.pagos.detalle[p].intereses_moratorios);

				$scope.pagos.detalle[p].condonado = $scope.pagos.detalle[p].condonado > $scope.pagos.detalle[p].intereses_moratorios ? $scope.pagos.detalle[p].intereses_moratorios : $scope.pagos.detalle[p].condonado;

				$scope.pago_realizado.monto			+= isNaN(parseFloat($scope.pagos.detalle[p].monto)) ? 0 : parseFloat($scope.pagos.detalle[p].monto);
				$scope.pago_realizado.condonado		+= isNaN(parseFloat($scope.pagos.detalle[p].condonado)) ?  0 : parseFloat($scope.pagos.detalle[p].condonado);
			// }
		}

		//console.log($scope.pago_realizado);

		$scope.calcular_pago();
	}

	$scope.calcular_pago = function() {
		//Loading.show();
		$scope.ready = false;
		
		var pago_por_realizar = (($scope.pagos.pago.capital+$scope.pagos.pago.intereses)*(1-parseFloat($scope.pago_realizado.comision*0.01))) + parseFloat($scope.pagos.pago.intereses_moratorios) + parseFloat($scope.pagos.pago.seguro);
		
		var monto = parseFloat($scope.pago_realizado.monto) + parseFloat($scope.pago_realizado.condonado) + parseFloat($scope.pagos.pago.saldo_afavor);
		
		var restante = pago_por_realizar > monto ? pago_por_realizar - monto : 0;
		var afavor = pago_por_realizar < monto ? monto -  pago_por_realizar : 0;

		$scope.pago = {
			"restante" : restante,
			"afavor" : afavor
		};
		$scope.getMaxCondonado();
		$scope.ready = true;
	};

	$scope.getMaxCondonado = function() {
		if('pagos' in $scope && 'pago' in  $scope.pagos) {
			const maximus = (($scope.pagos.pago.capital + $scope.pagos.pago.intereses) * (1 - parseFloat($scope.pago_realizado.comision)*0.01)) + parseFloat($scope.pagos.pago.intereses_moratorios) - $scope.pagos.pago.capital;
			if($scope.pago_realizado.condonado > maximus && !$scope.AuthService('app.admin')){
				$scope.pago_realizado.condonado = maximus;
			}
			// $scope.calcular_pago();
		}
	};

	$scope.get_pago = function() {
		// Loading.show();
		$scope.ready = false;
		
		$scope.pago_realizado.id = $scope.pago_realizado.distribuidor_id ? $scope.pago_realizado.distribuidor_id : $scope.pago_realizado.contrato_id;
		$scope.pago_realizado.target = $scope.pago_realizado.distribuidor_id ? 'distribuidor' : 'contrato';

		requests = [
			Vales.due($scope.pago_realizado),
			Vales.comision($scope.pago_realizado)
		];
		
		$q.all(requests).then(function(data){
			$scope.pagos = data[0].data;
			$scope.pago_realizado.comision = data[1].data.comision;
			$scope.calcular_pago();
			$scope.ready = true;
			// Loading.hide();
		});
	};

	$scope.doPago = function() {
		if( parseFloat($scope.pago.monto_condonado) > $scope.pagos.moratorios_intereses ){
			$ionicPopup.alert({
				title: 'Error en el pago',
				template: 'El pago condonado no puede ser mayor los intereses moratorios'
			});
			return;
		};		

		console.log('Doing pago', $scope.usuario);
		Loading.show();
	
		if(!parseInt($stateParams.ContratoId)){
			Distribuidor.pay($scope.por_pagar.distribuidor_id, $scope.pago_realizado).then(function(data){
				console.log(data);
				Loading.hide();
				if(data.status !== 'ERROR' && 'data' in data){
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Pago Realizado!',
						template: JSON.stringify($filter('currency')(data.data[0].monto))
					})
					
					$scope.alertPopup.then(function(){
						$window.open('https://api.avanzamas.net/distribuidor/recibo/pago/'+data.data[0].pago_id+'/1?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
						$scope.loadCaja($scope.estado);
						$scope.closePago();
					});
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
	
					});
				}
			});	
		}else{
			Contrato.pay($stateParams.ContratoId, $scope.pago_realizado).then(function(data){
				console.log(data);
				Loading.hide();
				if(data.status !== 'ERROR' && 'data' in data){
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Pago Realizado!',
						template: JSON.stringify($filter('currency')(data.data[0].monto))
					})
					
					$scope.alertPopup.then(function(){
						$window.open('https://api.avanzamas.net/distribuidor/recibo/pago/'+data.data[0].pago_id+'/1?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
						$scope.loadCaja($scope.estado);
						$scope.closePago();
					});
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
	
					});
				}
			});	
		}
	};
})

.controller('CajaHistorialCtrl', function($scope, $stateParams, Loading, Pagos, Distribuidor) {
	Distribuidor.get($stateParams.DistribuidorId).then(function(data){
		$scope.distribuidor = data.data;
		Pagos.history($stateParams.DistribuidorId).then(function(data){
			var proyecciones = data.data;
			$scope.proyecciones = [];
	
			for(p in proyecciones){
				var diferencia = (p-1 >= 0) ? parseFloat(proyecciones[p-1].diferencia) : 0;
				proyecciones[p].intereses_moratorios = parseFloat(proyecciones[p].intereses_moratorios);

				proyecciones[p].comision = proyecciones[p].comision ==  null ? 0 : proyecciones[p].comision;

				// proyecciones[p].monto =  (p-1 >= 0) && proyecciones[p].fecha_realizada == proyecciones[p-1].fecha_realizada ? parseFloat(proyecciones[p].monto)+diferencia : parseFloat(proyecciones[p].monto);
				// proyecciones[p].monto =  (p-1 >= 0) && proyecciones[p].fecha_programada === proyecciones[p-1].fecha_programada ? parseFloat(proyecciones[p].monto)+proyecciones[p].saldo_afavor_anterior : parseFloat(proyecciones[p].monto);

				
				proyecciones[p].diferencia_anterior = (p-1 >= 0) ? parseFloat(proyecciones[p-1].diferencia) : 0;
				
				proyecciones[p].pago_esperado = (p-1 >= 0) && proyecciones[p].fecha_programada === proyecciones[p-1].fecha_programada ? proyecciones[p].diferencia_anterior : $scope.get_pagoProyectado(proyecciones[p]);
				
				proyecciones[p].pago_proyectado = parseFloat(proyecciones[p].pago_esperado);
 
				proyecciones[p].diferencia = parseFloat(proyecciones[p].intereses_moratorios) + proyecciones[p].pago_proyectado + parseFloat(proyecciones[p].monto) + parseFloat(proyecciones[p].condonado)+ ( (p-1 >= 0) && proyecciones[p].fecha_programada === proyecciones[p-1].fecha_programada ? 0 : proyecciones[p].diferencia_anterior );

				// proyecciones[p].diferencia = proyecciones[p].saldo_afavor;
				// proyecciones[p].diferencia_anterior = proyecciones[p].saldo_afavor_anterior;
				
				$scope.proyecciones[(proyecciones.length-1)-p] = proyecciones[p];
			}
			
			Loading.hide();
		});
	});

	$scope.get_pagoReal = function(proyeccion){
		return parseFloat(proyeccion.capital_real)+parseFloat(proyeccion.interes_real);
	};

	$scope.get_comision = function(proyeccion){
		return -1*(parseFloat(proyeccion.capital_real)+parseFloat(proyeccion.interes_real))*parseFloat(proyeccion.comision)*0.01;
	}

	$scope.get_pagoProyectado = function(proyeccion){
		return (parseFloat(proyeccion.capital_real)+parseFloat(proyeccion.interes_real))*(100-parseFloat(proyeccion.comision))*0.01;
	}

	Loading.show();

})

.controller('PagosCtrl', function($scope, $state, Loading, $ionicPopup, Pagos, $timeout, ApiEndpoint) {
	$scope.$on('$ionicView.enter', function () {
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
		$scope.pagos = {};
		
		$scope.query = {
			type : 'fullName',
			value : ''
		};
	
		$scope.api_url = ApiEndpoint.url;
		$scope.public = localStorage.public;
		
		$scope.loadPage($scope.page);
	});

	$scope.loadPage = function(p){
		Pagos.count().then(function(data){
			console.log(data);
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		console.log(p);
		if(p===''){ return; };
		Loading.show();
		Pagos.search($scope.query, p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.pagos = data.data;
				console.log(data);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});	
	};

	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.loadPage($scope.page);
		}
	};
	
	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.loadPage($scope.page);
		}
	};

	$scope.cancelarPago = function(pago){
		$ionicPopup.prompt({
			title: 'Cancelar Pago',
			template: 'Estas por cancelar el pago '+pago.pago_id,
			inputType: 'text',
			inputPlaceholder: 'Razón'
		}).then(function(res) {
			pago.cancelacion_razon = res;
			Pagos.cancelar(pago).then(function(data){
				console.log(data);
				$scope.loadPage($scope.page);
			});
		});
	};

	$scope.autorizarPago = function(pago){
		$ionicPopup.confirm({
			title: 'Autorizar Pago',
			template: 'Estas por autorizar el pago '+pago.pago_id,
		}).then(function(res) {
			if(res){
				Pagos.autorizar(pago).then(function(data){
					console.log(data);
					$scope.loadPage($scope.page);
				});
			}
		});
	};

	$scope.queryPAgos = function(){
		$timeout(function() {
			$scope.page = 1;
			Loading.show();
			Pagos.search($scope.query, $scope.page).then(function(data){
				Loading.hide();
				if(data.status !== 'ERROR'){
					$scope.pagos = data.data;
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			})
			, 3000
		});
	};
})

.controller('StatsDistribuidorCtrl', function($scope, $state, $stateParams, Loading, Stats) {
	$scope.$on('$ionicView.enter', function() {
		Loading.show();

		Stats.distribuidor_actual($stateParams.DistribuidorId).then(function(data){
			Loading.hide();
			$scope.actual = data.data;
		});

		Stats.distribuidor_pendiente($stateParams.DistribuidorId).then(function(data){
			Loading.hide();
			$scope.pendiente = data.data;
		});

		Stats.distribuidor_vencidos($stateParams.DistribuidorId).then(function(data){
			Loading.hide();
			$scope.vencidos = data.data;
		});

		Stats.distribuidor_proyectados($stateParams.DistribuidorId).then(function(data){
			Loading.hide();
			$scope.proyectados = data.data;
		});

		$scope.viewContrato = function(vencido){
			$state.go('app.contrato', { 'ContratoId': vencido.contrato });
		};

		$scope.viewCliente = function(id){
			$state.go('app.cliente', { 'ClienteId': id});
		};
	});
})

.controller('ClientesCtrl', function($state, $scope, $timeout, $ionicPopup, Loading, Cliente, Credito) {
	
	$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
	$scope.clientes = {};

	if($state.current.name = 'Clientes'){
		$scope.title = 'Clientes';
	}else{
		$scope.title = 'Distribuidores';
	}
	
	$scope.query = {
		type : 'fullName',
		value : ''
	};
	
	
	$scope.loadPage = function(p){
		Cliente.count().then(function(data){
			console.log(data);
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		console.log(p);
		if(p===''){ return; };
		Loading.show();
		Cliente.all(p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.clientes = data.data;
				console.log($scope.clientes);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});	
	};

	$scope.loadPage($scope.page);
	
	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.loadPage($scope.page);
		}
	};

	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.loadPage($scope.page);
		}
	};

	$scope.newCliente = function(){
		$state.go('app.cliente', { ClienteId: 'new'});
	};
	
	$scope.viewCliente = function(id){
		$state.go('app.cliente', { ClienteId: id});
	};
	
	
	//$scope.loadPage($scope.page);
	//AQUIESTAMOS
	$scope.queryCliente = function(){
		$timeout(function() {
			$scope.page = 1;
			Loading.show();
			Cliente.search($scope.query, $scope.page).then(function(data){
				Loading.hide();
				if(data.status !== 'ERROR'){
					$scope.clientes = data.data;
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			})
		}, 3000);
	};
	
})

.controller('ClienteBusqueda', function($q, $state, $scope, $ionicPopup, Cliente) {
	if($state.current.name == 'app.vales'){
		var current = $scope.dataVales;
	}else if ($state.current.name == 'app.new_contrato') {
		var current = $scope.contrato;
	} else {
		var current = $scope.canje;
		console.log($state.current.name);
	}

	
	$scope.removeOption = function(e){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar '+ e,
			template: 'Estas Seguro que quieres eliminar el '+e+'?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				current.cliente_temp = "";
				current.cliente = {};
				current.cliente_id = "";
				console.log(current.cliente);
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.goNewCliente = function(){
		localStorage.setItem('clienteCanje', JSON.stringify(current));
		'cliente' in current && typeof current.cliente.cliente_id !== "undefined" ?
			$state.go('app.cliente', { ClienteId: current.cliente.cliente_id }) :
			$state.go('app.cliente', { ClienteId: 'new'});
	};

	$scope.autocomplete_cliente = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			onSelectCliente(selected);
        },
		debounce_suggest: 500
	};

	function highlight(str, term) {
		var highlight_regex = new RegExp('(' + term + ')', 'gi');
		return str.replace(highlight_regex, '<span class="highlight">$1</span>');
	};

	function fuzzy_suggest_cliente(t) {
		if(t == $scope.cliente_temp) return;

		var params = {
			type : 'fullName',
			producto_id : '1,2',
			multiplo : 1000,
			value : t
		};
		var deferred = $q.defer();
		Cliente.search(params, 1).then(function(data){
			if(data.data.length == 0) return;

			clientes = data.data.map(function (i){
				let cliente = i;
				cliente.nombre_completo = i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;

				return cliente;
			});

			var fuzzySearch = new Fuse(data.data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 1,
				keys: ['nombre','nombre_segundo','apellido_paterno','apellido_materno', 'nombre_completo']
			});
			if(data.data.length == 1){
				var busqueda = data.data
					.map(function(i) {
						var val = '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.cliente_id + '</span>' + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno + '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.curp + '</span>';
						// var val = "(" + i.cliente_id + ") " + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;
						return {
							id : i.cliente_id,
							item: i,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}else{
				var busqueda = fuzzySearch.search(t)
					.map(function(i) {
						// var val = "(" + i.item.cliente_id + ") " + i.item.nombre + " " + i.item.nombre_segundo + " " + i.item.apellido_paterno + " " + i.item.apellido_materno;
						var val = '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.item.cliente_id + '</span>' + i.item.nombre + " " + i.item.nombre_segundo + " " + i.item.apellido_paterno + " " + i.item.apellido_materno + '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.item.curp + '</span>';

						return {
							id : i.item.cliente_id,
							item: i.item,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}
			deferred.resolve(busqueda);
		});

		return deferred.promise;
	};

	function onSelectCliente(selected) {
		current.cliente_id = selected.item.cliente_id;
		current.cliente =  selected.item;
		current.cliente.saldo_insoluto = 0;
		for(c in  selected.item.contratos){
			if(selected.item.contratos[c].estado == 'ACTIVO') current.cliente.saldo_insoluto  += parseFloat(selected.item.contratos[c].saldo_insoluto);
		}
		current.contratos = current.cliente.contratos;
		console.log(current);
	}
})

.controller('CanjearValeCtrl', function($scope, $state, $ionicPopup, $q, $filter, Distribuidor, Cliente, Credito, Vales, $window, ApiEndpoint, AuthService){
	
	$scope.canje = {};
	$scope.canje.cliente = {};
	$scope.canje.plazo_pagos = "120";
	$scope.canje.getVale = {};
	$scope.canje.activos = 0;
	$scope.canje.contratos = {};
	$scope.canje.producto = {
		montos: [],
		plazos: []
	};
	$scope.enviroment = localStorage.enviroment;
	$scope.public = localStorage.public;

	if('clienteCanje' in localStorage  && localStorage.clienteCanje !== 'undefined'){
		$scope.canje = JSON.parse(localStorage.clienteCanje);
		localStorage.removeItem('clienteCanje');
	}

	if('cliente_temp' in localStorage){
		var cc = JSON.parse(localStorage.cliente_temp);
		$scope.canje.cliente.cliente_id = cc.cliente_id;
		$scope.canje.cliente_temp = '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + cc.cliente_id + '</span>' + cc.nombre + " " + cc.nombre_segundo + " " + cc.apellido_paterno + " " + cc.apellido_materno + '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + cc.curp + '</span>';
		$scope.canje.cliente.saldo_insoluto = 0;
		$scope.canje.contratos = cc.contratos;
		localStorage.removeItem('cliente_temp');
	}

	$scope.AuthService = function(p){
		return AuthService.isAuthorized(p);
	}

	$scope.getTotal = function(){
		//$scope.canje.producto_id = $scope.canje.getVale.producto_id;
		Vales.interes($scope.canje).then(function(d){
			try {
				$scope.canje.producto_sub = d.data;
				$scope.canje.pago = Credito.pago($scope.canje.monto.monto,d.data.interes/360*15, $scope.canje.plazo_pagos.periodos_max);
				$scope.canje.total =  $scope.canje.pago*($scope.canje.plazo_pagos.periodos_max);
				//$scope.pago = $scope.pago/$scope.canje.plazo_pagos/15;
			} catch (e) {
				console.warn(e);
			}
		});
	};

	$scope.canjearVale = function(cv){
		console.log($scope.canje.activos);
		console.log($scope.canje.getVale);
		if($scope.canje.caducado == 1){
			$scope.alertPopup = $ionicPopup.alert({
				title: 'Error!',
				template: "Vale Caducado"
			});
			return;
		}
		if(parseFloat($scope.canje.getVale.saldo) >= $scope.canje.total){
			// debugger
			if($scope.canje.cliente.saldo_insoluto+parseFloat($scope.canje.monto.monto) <= 10000){
				cv.fecha_canje = $filter('date')(cv.fecha_canje, "yyyy-MM-dd");
				Distribuidor.refUpdate(cv).then(
				function(data){
					if('data' in data){				
						console.log(data.data);
						////
						$window.open(ApiEndpoint.url+'cliente/pagare/' + data.data.contrato_id + '/1/?enviroment='+localStorage.enviroment+'&avanzamas-token=' + localStorage.public, '_NEW');
						$state.go('app.contrato', { 'ContratoId': data.data.contrato_id });
					}
				},function(error){
					// Loading.hide();
					console.log(error);
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: "No puede canjear este vale" + JSON.stringify(error)
					});
				});
			} else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: "No puede canjear este vale porque su saldo insoluto es mayor a $10,000.00"
				});
			}
		} else{
			$scope.alertPopup = $ionicPopup.alert({
				title: 'Error!',
				template: "El saldo disponible es insuficiente"
			});
		}
	}

	$scope.autocomplete_folio = {
        suggest: fuzzy_suggest_folio,
        on_select: function(selected) {
			if(selected.item.caducado == 1){
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: "Vale Caducado"
				});
				return;
			}
			$scope.canje.getVale = selected.item;
			$scope.getSRC();
			console.log($scope.canje.getVale);
			$scope.canje.referencia_id = selected.item.referencia_id;

			$scope.canje.caducado = selected.item.caducado;
			$scope.canje.producto = selected.item.producto;

			if($scope.canje.producto.montos.length > 0){
				for(monto in $scope.canje.producto.montos){
					if($scope.canje.producto.montos[monto].monto == selected.item.monto) $scope.canje.monto = $scope.canje.producto.montos[monto];
				}
				for(plazo in $scope.canje.producto.plazos){
					if($scope.canje.producto.plazos[plazo].periodos_max == selected.item.plazo_pagos/15) $scope.canje.plazo_pagos = $scope.canje.producto.plazos[plazo];
				}
			}else{
				$scope.canje.monto = selected.item.monto;
				$scope.canje.plazo_pagos = selected.item.plazo_pagos;
			}
			
			$scope.getTotal();
			$scope.canje.distribuidorLabel = "("+selected.item.distribuidor_id+") "+selected.item.nombre+" "+selected.item.nombre_segundo+ " " +selected.item.apellido_paterno+ " "+selected.item.apellido_materno;
			if( $scope.canje.getVale.cliente_id ){
				$scope.canje.cliente_id = selected.item.cliente_id;
				$scope.canje.cliente =  selected.item.cliente;
				$scope.canje.cliente_temp = '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + selected.item.cliente.cliente_id + '</span>' + selected.item.cliente.nombre + " " + selected.item.cliente.nombre_segundo + " " + selected.item.cliente.apellido_paterno + " " + selected.item.cliente.apellido_materno + '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + selected.item.cliente.curp + '</span>';
				$scope.canje.cliente.saldo_insoluto = 0;
				$scope.canje.cliente.contratos = selected.item.cliente.contratos;
				for(c in  selected.item.cliente.contratos){
					$scope.canje.cliente.saldo_insoluto  += parseFloat(selected.item.cliente.contratos[c].saldo_insoluto);
				}
				$scope.canje.contratos = $scope.canje.cliente.contratos;
			}
		}
	};

	$scope.removeOption = function(e){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar '+ e,
			template: 'Estas Seguro que quieres eliminar el '+e+'?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				$scope.canje.cliente_temp = "";
				$scope.canje.cliente = {};
				$scope.canje.cliente_id = "";
				console.log($scope.canje.cliente);
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.goNewCliente = function(){
		localStorage.setItem('clienteCanje', JSON.stringify($scope.canje));
		'cliente' in $scope.canje && typeof $scope.canje.cliente.cliente_id !== "undefined" ?
			$state.go('app.cliente', { ClienteId: $scope.canje.cliente.cliente_id }) :
			$state.go('app.cliente', { ClienteId: 'new'});
	}

	function highlight(str, term) {		
		var highlight_regex = new RegExp('(' + term + ')', 'gi');
		return str.replace(highlight_regex, '<span class="highlight">$1</span>');
	};

	function fuzzy_suggest_folio() {
		var deferred = $q.defer();
		Distribuidor.getCanjearVale($scope.canje.folio).then(function(d){
			var busqueda = d.data
				.slice(0,9)
				.map(function(i) {
					return {
						item : i,
						value: i.folio,
						label: '<div class="container-fluid">' +
							'  <div class="pull-left">' +
							highlight(i.folio) +
							'  </div>' +
							'</div>'
					};
				});
			deferred.resolve(busqueda);
		});
		return deferred.promise;
	};

	$scope.autocomplete_cliente = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			onSelectCliente(selected);
        },
		debounce_suggest: 500
	};

	function onSelectCliente(selected) {
		$scope.canje.cliente_id = selected.item.cliente_id;
		$scope.canje.cliente =  selected.item;
		$scope.canje.cliente.saldo_insoluto = 0;
		for(c in  selected.item.contratos){
			if(selected.item.contratos[c].estado == 'ACTIVO'){
				$scope.canje.cliente.saldo_insoluto  += parseFloat(selected.item.contratos[c].saldo_insoluto);
			}
		}
		$scope.canje.contratos = $scope.canje.cliente.contratos;
		console.log($scope.canje);
	}

	function fuzzy_suggest_cliente(t) {
		if(t == $scope.cliente_temp) return;

		var params = {
			type : 'fullName',
			producto_id : '1,2',
			multiplo : 1000,
			value : t
		};
		var deferred = $q.defer();
		Cliente.search(params, 1).then(function(data){
			if(data.data.length == 0) return;

			clientes = data.data.map(function (i){
				let cliente = i;
				cliente.nombre_completo = i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;

				return cliente;
			});

			var fuzzySearch = new Fuse(data.data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 1,
				keys: ['nombre','nombre_segundo','apellido_paterno','apellido_materno', 'nombre_completo']
			});
			if(data.data.length == 1){
				var busqueda = data.data
					.map(function(i) {
						var val = '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.cliente_id + '</span>' + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno + '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.curp + '</span>';
						// var val = "(" + i.cliente_id + ") " + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;
						return {
							id : i.cliente_id,
							item: i,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}else{

				var busqueda = fuzzySearch.search(t)
					.map(function(i) {
						var val = '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.cliente_id + '</span>' + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno + '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.curp + '</span>';
						// var val = "(" + i.item.cliente_id + ") " + i.item.nombre + " " + i.item.nombre_segundo + " " + i.item.apellido_paterno + " " + i.item.apellido_materno;
						return {
							id : i.item.cliente_id,
							item: i.item,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}
			deferred.resolve(busqueda);
		});

		return deferred.promise;
	};

	$scope.getSRC = function () {
		distribuidor = $scope.canje.getVale.distribuidor_id.padStart(3, "0");
		$scope.img = 'https://api.avanzamas.net/attachment/distribuidor/firmas/'+distribuidor+'?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public;
	};
})

.controller('CortesCtrl', function($scope, $filter, $window, Distribuidor, Loading, $state){

	$scope.corte = {
		"dia_corte" : "06",
		"mes_corte" : new Date()
	};

	$scope.cortes = [];
	$scope.distribuidores_activos = [];
	$scope.file_zip = "";
	$scope.name = $state.name;

	$state.current.name == 'app.distribuidor' ? $scope.currentName = 'Distribuidor' : $scope.currentName = 'Distribuidores';

	$scope.getActivos = function(month, day){
		$scope.cortes = [];
		$scope.fecha_corte = $filter('date')(month, 'yyyy-MM-')+day;
		console.log($scope.fecha_corte);
		Distribuidor.getActive($scope.fecha_corte).then(function(d){
			console.log(d.data);
			$scope.distribuidores_activos = d.data;
		});
	}

	$scope.select = function () {
		$scope.fecha_corte = $filter('date')($scope.corte.mes_corte, 'yyyy-MM-')+$scope.corte.dia_corte;
	}

	$scope.select();

	$scope.genCortes = function(i){
		if($scope.currentName != 'Distribuidores'){
			$scope.distribuidores_activos = [$scope.currentID];
		}
		console.log($scope.currentCortes);
		console.log($scope.distribuidores_activos);
		var requests = [];
		$scope.cortes = [];
		$scope.file_zip = "";
		Loading.show();

		$scope.currentCortes == "Cortes" ? toggle = "getCorte": toggle = "getRecibos";
		for(var i = 0; i < $scope.distribuidores_activos.length; i++){
			requests.push(Distribuidor[toggle](i,$scope.distribuidores_activos[i], $scope.fecha_corte).then(function(d){
				$scope.cortes[d.index] = d.data;
				if($scope.cortes.length == $scope.distribuidores_activos.length){
					Loading.hide();
				}
			}));
		}
	};

	$scope.downloadCortes = function(){ 
		Loading.show();
		if($scope.currentCortes == "Cortes"){
			Distribuidor.downloadCortes($scope.cortes, $scope.fecha_corte).then(function(d){
				$window.open(d.data,'_NEW');
				$scope.file_zip = d;
				Loading.hide();
			});
		}else{
			Distribuidor.downloadRecibos($scope.cortes, $scope.fecha_corte).then(function(d){
				$window.open(d.data,'_NEW');
				$scope.file_zip = d;
				Loading.hide();
			});
		}
	};

	$scope.printCortes = function(type){
		console.log(type);
		if(type === 'Recibos'){
			$window.open('https://api.avanzamas.net/distribuidor/0/recibo/cliente/'+$scope.fecha_corte+'/1/?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
		} else {
			Loading.show();
			Distribuidor.printCortes($scope.cortes, $scope.fecha_corte).then(function(d){
				$window.open(d.data,'_NEW');
				Loading.hide();
			});
		}
	};
})

.controller('DistribuidoresCtrl', function($state, $scope, $timeout, $ionicPopup, $ionicModal, Loading, Distribuidor, Credito, $rootScope) {
	$scope.$on('$ionicView.enter', function () { 
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
		$scope.clientes = {};
	
		if($state.current.name == 'app.clientes'){
			$scope.title = 'Clientes';
		}else{
			$scope.title = 'Distribuidores';
		}
	
		$scope.tittle = 'Distribuidores';
	
		$scope.query = {
			type : 'fullName',
			value : ''
		};

	    $scope.loadPage($scope.page);
	});

	$scope.loadPage = function(p){
		Distribuidor.count().then(function(data){
			console.log(data);
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		console.log(p);
		if(p===''){ return; };
		Loading.show();
		Distribuidor.all(p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.clientes = data.data;
				console.log($scope.clientes);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});	
	};
	
	$scope.newCliente = function(){
		$state.go('app.distribuidor', { ClienteId: 'new'});
	};
	
	$scope.viewCliente = function(id){
		$state.go('app.distribuidor', { ClienteId: id});
	};

	$ionicModal.fromTemplateUrl('templates/generar_cortes.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modalCortes = modal;
	});

	$scope.closeModal = function() {
		$scope.modalCortes.hide();
	};

	$scope.getCortes = function(d, id){
		$scope.currentCortes = d;
		$scope.modalCortes.show();
	};
	
	$scope.loadPage($scope.page);
	
	$scope.queryCliente = function(){
		$timeout(function() {
			$scope.page = 1;
			Loading.show();
			Distribuidor.search($scope.query, $scope.page).then(function(data){
				Loading.hide();
				if(data.status !== 'ERROR'){
					$scope.clientes = data.data;
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			})
			, 3000
		});
	};

	$scope.goPagare = function(c){
		$state.go('app.pagares', { ClienteId: c.cliente_id});
	};

	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.loadPage($scope.page);
		}
	};

	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.loadPage($scope.page);
		}
	};

})

.controller('PromotoriaCtrl', function($state, $scope, $timeout, $ionicPopup, $ionicModal, Loading, Distribuidor, Credito, $rootScope) {
	
	$scope.$on('$ionicView.enter', function () { 
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
		$scope.clientes = {};
		$scope.promotoria = true;
		$scope.tittle = 'PROMOTORIA';
	
		$scope.query = {
			type : 'fullName',
			value : ''
		};

	    $scope.loadPage($scope.page);
	});

	$scope.loadPage = function(p){
		Distribuidor.count("'INACTIVO','APROBACION'").then(function(data){
			console.log(data);
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		console.log(p);
		if(p===''){ return; };
		Loading.show();
		Distribuidor.all(p,"'INACTIVO','APROBACION'").then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.clientes = data.data;
				console.log($scope.clientes);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});	
	};
	
	$scope.newCliente = function(){
		$state.go('app.distribuidor', { ClienteId: 'new'});
	};
	
	$scope.viewCliente = function(id){
		$state.go('app.distribuidor', { ClienteId: id});
	};

	$ionicModal.fromTemplateUrl('templates/generar_cortes.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modalCortes = modal;
	});

	$scope.closeModal = function() {
		$scope.modalCortes.hide();
	};

	$scope.getCortes = function(d, id){
		$scope.currentCortes = d;
		$scope.modalCortes.show();
	};
	
	$scope.queryCliente = function(){
		$timeout(function() {
			$scope.page = 1;
			Loading.show();
			Distribuidor.search($scope.query, $scope.page).then(function(data){
				Loading.hide();
				if(data.status !== 'ERROR'){
					$scope.clientes = data.data;
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			})
			, 3000
		});
	};

	$scope.goPagare = function(c){
		$state.go('app.pagares', { ClienteId: c.cliente_id});
	};

	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.loadPage($scope.page);
		}
	};

	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.loadPage($scope.page);
		}
	};

})

.controller('PagaresCtrl', function($q, $scope, $ionicPopup, $ionicModal, $stateParams, Loading, Distribuidor ){
	$scope.$on('$ionicView.enter', function() {
		$scope.pagares = {};
		$scope.monto = {};

		Distribuidor.getPagares($stateParams.ClienteId).then(function(data){
			$scope.pagares = data.data;

			// $scope.pagares = Object.keys($scope.pag).map(function(key) {
			// 	return [Number(key), $scope.pag[key]];
			// });
			// console.log($scope.pagares);
		});
	});

	$scope.doPagare = function(m){
		Distribuidor.doPagare(m, $stateParams.ClienteId).then(function(data){
			if('data' in data){
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Listo!',
					template: 'Pagaré Salvado'
				});
				Distribuidor.getPagares($stateParams.ClienteId).then(function(data){$scope.pagares = data.data;});
				$scope.monto = {};
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});
		$scope.modalDoPagare.hide();
	};
		
	$scope.delPagare = function(d){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar Pagaré',
			template: 'Estas Seguro que quieres eliminar el Pagaré?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				Distribuidor.delPagare(d).then(function(data){
					if(typeof data !== 'undefined'){
						//delete $scope.pagare.d;
						Distribuidor.getPagares($stateParams.ClienteId).then(function(data){$scope.pagares = data.data;});
					}else{
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
						});
					}
				});	
			} else {
				console.log('You are not sure');
			}
		});
	};

	$ionicModal.fromTemplateUrl('templates/doPagare.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modalDoPagare = modal;
	});

	$scope.openDoPagare = function(e) {
		$scope.modalDoPagare.show();
	};	

	$scope.closeDoPagare = function() {
		$scope.modalDoPagare.hide();
	};	
})

.controller('ClienteCtrl', function($q, $scope, $rootScope, $state, $ionicPopup, $ionicModal, $stateParams, Loading, Cliente, Distribuidor, Domicilio, Telefono, AuthService){
	if($state.current.name == 'app.distribuidor'){
		$scope.title = "Distribuidor";
		var state = 'distribuidor';
		var Current = Distribuidor;
		var ID = $stateParams.ClienteId;
	}else{
		$scope.title = "Cliente";
		var state = 'cliente';
		var Current = Cliente;
		var ID = $stateParams.ClienteId;
	}
	// $scope.$on('$ionicView.enter', function () {
		$scope.checkDiseable = function () {
			return $rootScope.current[$scope.state+'_id'] === null
		};
	
		$scope.AuthService = function(p){
			return AuthService.isAuthorized(p);
		}
	
		$scope.getSRC = function(t){
			return 'https://api.avanzamas.net/attachment/'+$scope.state+'/'+t+'/'+$stateParams.ClienteId.padStart(3, "0")+'?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public;
		};
		
		Loading.show();
		$rootScope.conyugeLabel = "";
		$rootScope.avalLabel = "";
		$rootScope.aval2Label = "";
		$rootScope.referencia1Label = "";
		$rootScope.referencia2Label = "";
		$scope.contratos_modal = {};
		$scope.parents = [];
		$scope.state = state;
	
		$scope.upload_file = {
			target: state,
			id: ID
		}
		$scope.img = {
			'firma': $scope.getSRC('firmas'),
			'ine': $scope.getSRC('ines'),
			'address': $scope.getSRC('addresses'),
			'casas': $scope.getSRC('casas'),
			'profiles': $scope.getSRC('profiles')
		};
	
		
		if('current' in $scope && 'cliente_id' in $scope.current && typeof $scope.current[state+'_id'] !== "undefined"){
			$rootScope.current = {
				conyuge_id : "",
				aval_id : "",
				referencia1_id : "",
				referencia2_id : ""
			};
		}else{
			$rootScope.current = {};
		}
		
		$rootScope.current[state+'_id'] = null;

		$scope.get_label = function(id, o)
		{
			if(id){
				return "(" + o.cliente_id+ ") " + o.nombre + " " + o.nombre_segundo + " " + o.apellido_paterno + " " + o.apellido_materno;
			}else{
				return'';
			}
		}	
		
		if('ClienteId' in $stateParams && ID !== 'new'){
			// var c = {"id" : ID, "current" : $scope.title.toLowerCase()};
			// console.log(c);
			Current.get(ID).then(function(data){
				Loading.hide();
				$scope.current = data.data;
				console.log($scope.current);
				$scope.getParents($scope.current);
				$rootScope.conyugeLabel = $scope.get_label($scope.current.conyuge_id, $scope.current.conyuge);

				$rootScope.aval1Label = $scope.get_label($scope.current.aval1_id, $scope.current.aval1);
				$rootScope.aval2Label = $scope.get_label($scope.current.aval2_id, $scope.current.aval2);

				$rootScope.referencia1Label = $scope.get_label($scope.current.referencia1_id, $scope.current.referencia1);
				$rootScope.referencia2Label = $scope.get_label($scope.current.referencia2_id, $scope.current.referencia2);

				$ionicModal.fromTemplateUrl('templates/contracts_cliente.html', {
					scope: $scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					$scope.contratos_modal = modal;
				});
			});
		}else{
			Loading.hide();
		}
	// });

	$ionicModal.fromTemplateUrl('templates/generar_cortes.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modalCortes = modal;
	});

	$scope.closeModal = function() {
		$scope.modalCortes.hide();
	};

	$scope.getCortes = function(d, id){
		$scope.currentCortes = d;
		$scope.currentID = id;
		$scope.modalCortes.show();
	};
	$scope.closeModal = function() {
		$scope.modalCortes.hide();
	};

	$scope.saveClienteData = function(){
		var ClientData = [];
		for(d in $scope.current.domicilios){
			if(typeof $scope.current.domicilios[d].domicilio_id == 'undefined'){
				$scope.current.domicilios[d][state+'_id'] = $scope.current[state+'_id'];
				ClientData.push(Domicilio.save($scope.current.domicilios[d]));	
			}else{
				ClientData.push(Domicilio.update($scope.current.domicilios[d]));
			}
		};

		for(d in $scope.current.domicilios_laboral){
			if(typeof $scope.current.domicilios_laboral[d].domicilio_id == 'undefined'){
				$scope.current.domicilios_laboral[d][state+'_id'] = $scope.current[state+'_id'];
				ClientData.push(Domicilio.save($scope.current.domicilios_laboral[d]));	
			}else{
				ClientData.push(Domicilio.update($scope.current.domicilios_laboral[d]));
			}
		};
		
		for(d in $scope.current.telefonos){
			if(typeof $scope.current.telefonos[d].telefono_id == 'undefined'){
				$scope.current.telefonos[d][state+'_id'] = $scope.current[state+'_id'];
				ClientData.push(Telefono.save($scope.current.telefonos[d]));	
			}else{
				ClientData.push(Telefono.update($scope.current.telefonos[d]));
			}
		};

		for(d in $scope.current.telefonos_laboral){
			if(typeof $scope.current.telefonos_laboral[d].telefono_id == 'undefined'){
				$scope.current.telefonos_laboral[d][state+'_id'] = $scope.current[state+'_id'];
				ClientData.push(Telefono.save($scope.current.telefonos_laboral[d]));	
			}else{
				ClientData.push(Telefono.update($scope.current.telefonos_laboral[d]));
			}
		};
		
		return $q.all(ClientData);
	}

	$scope.diccionario = {
		M: {
			PADRE: 'PADRE',
			HERMANO: 'HERMANO'
		},
		F: {
			PADRE: 'MADRE',
			HERMANO: 'HERMANA'
		}
	};

	$scope.setParent = function(c, i){
		var p = {
			'cliente_id' : c.cliente_original,
			'pariente_id' : c.cliente_id,
			'parentesco' : c.parentesco_proyectado
		};
		Current.setParent(p).then(function(data){
			c.parentesco_definido = typeof data.parentesco == 'undefined' ? null : data.parentesco;
			$scope.parents[i] = c;
		});
	};
	
	$scope.saveCliente = function(){
		Loading.show();
		Current.save($scope.current).then(function(data){
			$scope.current[state+'_id'] = data.data[state+'_id'];
			if('data' in data){
				$scope.saveClienteData().then(function(data){
					var error = false;
					
					Loading.hide();
					if(error){
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: JSON.stringify(data)
						});
					}else{
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Listo!',
							template: $scope.title+' Salvado'
						}).then(function(){
							if('clienteCanje' in localStorage && localStorage.clienteCanje !== 'undefined'){
								localStorage.setItem('cliente_temp', JSON.stringify($scope.current));
								$state.go('app.canjearVale');
								console.log("canje");
							}else{
								if($state.current.name == 'app.cliente'){
									$state.go('app.cliente', { ClienteId: $scope.current.cliente_id});
								}else if($state.current.name == 'app.distribuidor'){
									$state.go('app.distribuidor', { ClienteId: $scope.current.distribuidor_id});
								}
							}
						});
					}
				});
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )

				});
			}
		})
	};

	$scope.removeOption = function(e){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar '+ e,
			template: 'Estas Seguro que quieres eliminar el '+e+'?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				$rootScope[e+"Label"] = "";
				$scope.current[e+"_id"] = {};
				console.log($rootScope.conyugeLabel);
			} else {
				console.log('You are not sure');
			}
		});
	};

	//Modal NUEVO CONYUGE -->
	$scope.goNewClienteModal = function(e){
		console.log($scope.current[e+"_id"]);
		console.log($rootScope[e+"Label"]);
		$rootScope.newClienteModal = e;
		//$rootScope.newCliente = {};
		if($rootScope[e+"Label"] !== ''){
			Cliente.get($scope.current[e+"_id"], Current).then(function(data){
				$rootScope.newCliente = data.data;
				$rootScope.newCliente.conyuge_id = $scope.current[state+"_id"];
				$rootScope.newCliente.estado_civil = $scope.current.estado_civil;
				$rootScope.newClienteConyugeLabel = "(" + $scope.current[state+"_id"]+ ") " + $scope.current.nombre + " " + $scope.current.nombre_segundo + " " + $scope.current.apellido_paterno + " " + $scope.current.apellido_materno;
				$ionicModal.fromTemplateUrl('templates/nuevoCliente_modal.html', {
					backdropClickToClose: false,
					hardwareBackButtonClose: false,
					animation: 'slide-in-up',
				}).then(function(modal) {
					$scope.modalNewClienteModal = modal;
					$scope.modalNewClienteModal.show();
					console.log($rootScope.newCliente);
				});
			});
		}else{
			$scope.current[e+"_id"] = '';
			$rootScope.newCliente = {};
			$rootScope.newCliente.conyuge_id = $scope.current[state+"_id"];
			$rootScope.newCliente.estado_civil = $scope.current.estado_civil;
			$rootScope.newClienteConyugeLabel = "(" + $scope.current[state+"_id"]+ ") " + $scope.current.nombre + " " + $scope.current.nombre_segundo + " " + $scope.current.apellido_paterno + " " + $scope.current.apellido_materno;
			$ionicModal.fromTemplateUrl('templates/nuevoCliente_modal.html', {
				backdropClickToClose: false,
				hardwareBackButtonClose: false,
				animation: 'slide-in-up',
			}).then(function(modal) {
				$scope.modalNewClienteModal = modal;
				$scope.modalNewClienteModal.show();
				console.log($rootScope.newCliente);
			});
		}
	};

	$rootScope.closeNewClienteModal = function(e, m) {
		if(typeof m !== 'undefined'){
			// e?"conyuge":$scope.current.conyuge_id = $rootScope[$rootScope.newClienteModal].cliente_id;
			$scope.current[e+"_id"] = m.cliente_id;
			console.log($scope.current[e+"_id"]);
			$scope.modalNewClienteModal.hide();
		}else{
			$scope.modalNewClienteModal.hide();
		}
	};

	$scope.getParents = function(cliente){
		Cliente.getParents(cliente).then(function(data){
			$scope.parents = data.data;
		});
	};

	$scope.get_contracts = function(i) {
		$scope.contratos_modal.show();
	};
	
	$scope.closeContracts = function() {
		$scope.contratos_modal.hide();
	};
	
	$scope.getRealtedAddress = function(address){
		var a = {
			"num_ext" : address.num_ext,
			"calle" : address.calle,
			"colonia" : address.colonia
		};
		Cliente.getRealtedAddress(a).then(function(data){
			$scope.address = data;
		});
	};
	
	
	$scope.addDomicilio = function(e){
		if(Array.isArray($scope.current[e])){
			$scope.current[e].push({
				tipo: e === "domicilios" ? 'personal' : 'laboral'
			});
		}else{
			$scope.current[e] = [
				{
					tipo: e === "domicilios" ? 'personal' : 'laboral'
				}
			];
		}
	};
	
	$scope.removeDomicilio = function(i, d, e){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar Domicilio',
			template: 'Estas Seguro que quieres eliminar el domicilio?'
		});

		confirmPopup.then(function(res) {
			if(res) {
				console.log('You are sure');
				if(d.domicilio_id){
					Domicilio.del(d).then(function(data){
						if(typeof data !== 'undefined'){
							$scope.current[e].splice(i, 1);
						}else{
							$scope.alertPopup = $ionicPopup.alert({
								title: 'Error!',
								template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )

							});
						}
					});
				}else{
					$scope.current[e].splice(i, 1);
				}
			} else {
				console.log('You are not sure');
			}
		});
	};
	 
	$scope.addTelefono = function(e){
		if(Array.isArray($scope.current[e])){
			$scope.current[e].push({
				cliente_id : $scope.current[state+'_id'],
				tipo: e,
				telefono : ''
			});
		}else{
			$scope.current[e] = [
				{
					cliente_id : $scope.current[state+'_id'],
					tipo: e,
					telefono : ''
				}
			];
		}
	};

	$scope.removeTelefono = function(i, d, e){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar Teléfono',
			template: 'Estas Seguro que quieres eliminar el teléfono?'
		});
		
		confirmPopup.then(function(res) {
			if(res) {
				console.log('You are sure');
				if(d.telefono_id){
					Telefono.del(d).then(function(data){
						if(typeof data !== 'undefined'){
							$scope.current[e].splice(i, 1);
						}else{
							$scope.alertPopup = $ionicPopup.alert({
								title: 'Error!',
								template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
							});
						}
					});
				}else{
					$scope.current[e].splice(i, 1);
				}
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.autocomplete_calle = {
        suggest: fuzzy_suggest,
        on_select: function(selected) {
			console.log(selected);
        }
	};
	
	function highlight(str, term) {
		var highlight_regex = new RegExp('(' + term + ')', 'gi');
		return str.replace(highlight_regex, '<span class="highlight">$1</span>');
	};

	function fuzzy_suggest(t) {
		var params = {
			col : 'calle',
			value : t
		};
		var deferred = $q.defer();
		Domicilio.proxy(params).then(function(data){

			var fuzzySearch = new Fuse(data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 1,
				keys: ['label']
			});
	
			var busqueda = fuzzySearch.search(t)
				.map(function(i) {
					var val = i.item.label ;
					return {
						value: val,
						label: '<div class="container-fluid">' +
							'  <div class="pull-left">' +
							highlight(val, t) +
							'  </div>' +
							'</div>'
					};
				});

			deferred.resolve(busqueda);
		});
		return deferred.promise;
	};
	
	$scope.autocomplete_conyuge = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			$rootScope.conyugeLabel = selected.value;
			$scope.current.conyuge_id = selected.id;
			console.log($scope.current.conyuge_id);
        }
	};

	$scope.autocomplete_aval = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			if(selected.id){
				$rootScope.avalLabel = selected.value;
				$scope.current.aval_id = selected.id;
				console.log($scope.current.aval_id);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Alerta!',
					template: 'Verifica la seleccion del Aval'
				});
			}
        }
	};

	$scope.autocomplete_referencia_1 = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			if(selected.id){
				$rootScope.referencia1Label = selected.value;
				$scope.current.referencia1_id = selected.id;
				console.log($scope.current.referencia1_id);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Alerta!',
					template: 'Verifica la seleccion de la referencia'
				});
			}
        }
	};

	$scope.autocomplete_referencia_2 = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			if(selected.id){
				$rootScope.referencia2Label = selected.value;
				$scope.current.referencia2_id = selected.id;
				console.log($scope.current.referencia2_id);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Alerta!',
					template: 'Verifica la seleccion de la referencia'
				});
			}
        }
	};

	function fuzzy_suggest_cliente(t) {
		if(t.length <= 3 || t == $scope.cliente_temp) return;

		var params = {
			type : 'fullName',
			producto_id : '1,2',
			multiplo : 1000,
			value : t
		};
		var deferred = $q.defer();
		Cliente.search(params, 1).then(function(data){
			if(data.data.length == 0) return;
			var fuzzySearch = new Fuse(data.data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 1,
				keys: ['nombre','nombre_segundo','apellido_paterno','apellido_materno', 'nombre_completo']
			});
			if(data.data.length == 1){
				var busqueda = data.data
					.map(function(i) {
						var val = "(" + i.cliente_id + ") " + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;
						return {
							id : i.cliente_id,
							item: i,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}else{

				var busqueda = fuzzySearch.search(t)
					.map(function(i) {
						var val = "(" + i.item.cliente_id + ") " + i.item.nombre + " " + i.item.nombre_segundo + " " + i.item.apellido_paterno + " " + i.item.apellido_materno;
						return {
							id : i.item.cliente_id,
							item: i.item,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}
			deferred.resolve(busqueda);
		});

		return deferred.promise;
	};
})

.controller('ClienteModalCtrl', function($q, $scope, $rootScope, $ionicPopup, Cliente, Telefono, Domicilio){
	$scope.modalHide = true;
	$scope.modalSelected = $rootScope.newClienteModal;
	$scope.current = typeof $rootScope.newCliente !== 'undefined' ? $rootScope.newCliente :  {};
	$scope.conyugeLabel = $rootScope.newClienteConyugeLabel;
	console.log($rootScope.newClienteConyugeLabel);
	$scope.closeModal = function(){
		console.log('cerrar');
		!$scope.conyugeLabel ? $scope.conyugeLabel = "" : $scope.conyugeLabel;
		$rootScope.closeNewClienteModal();
	}

	//ADD DOMICILIO Y CLIENTE
	$scope.getRealtedAddress = function(address){
		var a = {
			"num_ext" : address.num_ext,
			"calle" : address.calle,
			"colonia" : address.colonia
		};
		Cliente.getRealtedAddress(a).then(function(data){
			$scope.address = data;
		});
	};

	$scope.addDomicilio = function(){
		if(Array.isArray($scope.current.domicilios)){
			$scope.current.domicilios.push({});
		}else{
			$scope.current.domicilios = [{}];
		}
	};
	
	$scope.removeDomicilio = function(i, d){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar Domicilio',
			template: 'Estas Seguro que quieres eliminar el domicilio?'
		});

		confirmPopup.then(function(res) {
			if(res) {
				console.log('You are sure');
				if(d.domicilio_id){
					Domicilio.del(d).then(function(data){
						if(typeof data !== 'undefined'){
							$scope.current.domicilios.splice(i, 1);
						}else{
							$scope.alertPopup = $ionicPopup.alert({
								title: 'Error!',
								template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
	
							});
						}
					});
				}else{
					$scope.current.domicilios.splice(i, 1);
				}
				
			} else {
				console.log('You are not sure');
			}
		});
	};
	
	$scope.addTelefono = function(e){
		console.log(e);
		if(Array.isArray($scope.current[e])){
			$scope.current[e].push({
				cliente_id : $scope.current['cliente_id'],
				tipo: e,
				telefono : ''
			});
		}else{
			$scope.current[e] = [
				{
					cliente_id : $scope.current['cliente_id'],
					tipo: e,
					telefono : ''
				}
			];
		}
	};
	$scope.removeTelefono = function(i, d){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar Teléfono',
			template: 'Estas Seguro que quieres eliminar el teléfono?'
		});
		
		confirmPopup.then(function(res) {
			if(res) {
				console.log('You are sure');
				if(d.telefono_id){
					Telefono.del(d).then(function(data){
						if(typeof data !== 'undefined'){
							$scope.current.telefonos.splice(i, 1);
						}else{
							$scope.alertPopup = $ionicPopup.alert({
								title: 'Error!',
								template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
							});
						}
					});
				}else{
					$scope.current.telefonos.splice(i, 1);
				}
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.saveClienteData = function(){
		var ClientData = [];
		for(d in $scope.current.domicilios){
			if(typeof $scope.current.domicilios[d].domicilio_id  == 'undefined'){
				$scope.current.domicilios[d].cliente_id = $scope.current.cliente_id;
				ClientData.push(Domicilio.save($scope.current.domicilios[d]));	
			}else{
				ClientData.push(Domicilio.update($scope.current.domicilios[d]));
			}
		};
		for(d in $scope.current.telefonos){
			if(typeof $scope.current.telefonos[d].telefono_id == 'undefined'){
				$scope.current.telefonos[d].cliente_id = $scope.current.cliente_id;
				ClientData.push(Telefono.save($scope.current.telefonos[d]));	
			}else{
				ClientData.push(Telefono.update($scope.current.telefonos[d]));
			}
		};
		return $q.all(ClientData);
	}

	//SALVAR CLIENTE
	$scope.saveCliente = function(){
		Cliente.save($scope.current).then(function(data){
			if('data' in data){
				$rootScope[$rootScope.newClienteModal] = data.data;
				$rootScope[$rootScope.newClienteModal+'Label'] = "(" + data.data.cliente_id + ") " + data.data.nombre + " " + data.data.nombre_segundo + " " + data.data.apellido_paterno + " " + data.data.apellido_materno;
				$rootScope[$rootScope.newClienteModal+'_id'] = data.data.cliente_id;
				$scope.current.cliente_id = data.data.cliente_id;
				$scope.saveClienteData().then(function(data){
					var error = false;
					for(d in data){
						if(typeof data[d] == 'undefined') error = true;
					}
					if(error){
						// $rootScope.closeNewClienteModal();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: JSON.stringify(data)
						});
					}else{			
						$rootScope.closeNewClienteModal($scope.modalSelected, $scope.current);
					}
				});
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});
	};

	$scope.autocomplete_calle = {
        suggest: fuzzy_suggest,
        on_select: function(selected) {
			console.log(selected);
        }
	};

	function highlight(str, term) {
		var highlight_regex = new RegExp('(' + term + ')', 'gi');
		return str.replace(highlight_regex, '<span class="highlight">$1</span>');
	};

	function fuzzy_suggest(t) {
		var params = {
			col : 'calle',
			value : t
		};
		var deferred = $q.defer();
		Domicilio.proxy(params).then(function(data){

			var fuzzySearch = new Fuse(data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 0.05,
				keys: ['label']
			});
	
			var busqueda = fuzzySearch.search(t)
				.map(function(i) {
					console.log(i);
					var val = i.item.label ;
					return {
						value: val,
						label: '<div class="container-fluid">' +
							'  <div class="pull-left">' +
							highlight(val, t) +
							'  </div>' +
							'</div>'
					};
				});

			deferred.resolve(busqueda);
		});
		return deferred.promise;
	};

	$scope.autocomplete_conyuge = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			$rootScope.newCliente.conyugeLabel = selected.value;
			$rootScope.newCliente.conyuge_id = selected.id;
			console.log($rootScope.newCliente.conyuge_id);
        }
	};

	function fuzzy_suggest_cliente(t) {
		if(t.length <= 3 || t == $scope.cliente_temp) return;
		var params = {
			type : 'fullName',
			producto_id : '1,2',
			multiplo : 1000,
			value : t
		};
		var deferred = $q.defer();
		Cliente.search(params, 1).then(function(data){
			if(data.data.length == 0) return;
			var fuzzySearch = new Fuse(data.data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 1,
				keys: ['nombre','nombre_segundo','apellido_paterno','apellido_materno', 'nombre_completo']
			});
			if(data.data.length == 1){
				var busqueda = data.data
					.map(function(i) {
						var val = "(" + i.cliente_id + ") " + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;
						return {
							id : i.cliente_id,
							item: i,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}else{
				var busqueda = fuzzySearch.search(t)
					.map(function(i) {
						var val = "(" + i.item.cliente_id + ") " + i.item.nombre + " " + i.item.nombre_segundo + " " + i.item.apellido_paterno + " " + i.item.apellido_materno;
						return {
							id : i.item.cliente_id,
							item: i.item,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}
			deferred.resolve(busqueda);
		});

		return deferred.promise;
	};

	$scope.removeOption = function(e){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Eliminar '+ e,
			template: 'Estas Seguro que quieres eliminar el '+e+'?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				$rootScope.newCliente[e+"Label"] = "";
				$rootScope.newCliente[e+"_id"] = {};
				console.log($rootScope.newCliente);
			} else {
				console.log('You are not sure');
			}
		});
	};
})

.controller('ContratosClienteCtrl', function($scope, $state, $stateParams, Cliente){
	$scope.$on('$ionicView.enter', function () {
		if($state.current.name == 'app.cliente' && $stateParams.ClienteId !== 'new'){
			Cliente.contracts($stateParams.ClienteId).then(function(data){
				if(typeof data !== 'undefined' && 'data' in data) $scope.contratos = data.data;
			});
		};
	});
	
	$scope.viewContrato = function(id){
		$scope.contratos_modal.hide();
		$state.go('app.contrato', { 'ContratoId': id });
	};
	
	$scope.newContrato = function(){
		$scope.contratos_modal.hide();
		$state.go('app.new_contrato', { ClienteId: $stateParams.ClienteId });
	};

	$scope.closeContratos = function(){
		$scope.contratos_modal.hide();
	};
})

.controller('ClientesInfoFaltanteCtrl', function($q, $scope, $state, $ionicPopup, $stateParams, Loading, Buro, Distribuidor){
	$scope.$on('$ionicView.enter', function () { 
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
		$scope.clientes = {};

		$scope.query = {
			type : 'fullName',
			value : ''
		};

	    $scope.loadPage($scope.page);
	});
	
	$scope.loadPage = function(p){
		Buro.infoCount().then(function(data){
			console.log(data);
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		console.log(p);
		if(p===''){ return; };
		Loading.show();
		Buro.info(p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.clientes = data.data;
				console.log(data);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});	
	};
	
	$scope.viewCliente = function(id){
		$state.go('app.distribuidor', { ClienteId: id});
	};
	
	$scope.loadPage($scope.page);
	
	$scope.queryCliente = function(){
		Loading.show();
		Distribuidor.search($scope.query, $scope.page).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.clientes = data.data;
				console.log(data);
			}
		})
	};
	
	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.loadPage($scope.page);
		}
	};
	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.loadPage($scope.page);
		}
	};
})

.controller('ContratosCtrl', function($state, $scope, $timeout, $ionicPopup, $stateParams, Loading, Contrato, Contratos){
	$scope.$on('$ionicView.enter', function () { 
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
		$scope.contratos = {};
		$scope.query = {
			value: ''
		};
		$scope.loadPage($scope.page);
	});
	
	$scope.loadPage = function(p){
		Contratos.count('all').then(function(data){
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
			Loading.show();
			Contratos.search('all', p, $scope.query.value).then(function(data){
				Loading.hide();
				if(data.status !== 'ERROR'){
					$scope.contratos = data.data;
					console.log(data);
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			});	
		});
	};

	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.loadPage($scope.page);
		}
	};
	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.loadPage($scope.page);
		}
	};

	$scope.queryContratos = function(){
		Loading.show();
		Contratos.count('all', $scope.query.value).then(function(data){
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
			Contratos.search('all', $scope.page, $scope.query.value).then(function(data){
				Loading.hide();
				if(data.status !== 'ERROR'){
					$scope.contratos = data.data;
					console.log(data);
				}
			});
		});
	};

	$scope.viewContrato = function(id){
		//$scope.closeContracts();
		$state.go('app.contrato', { 'ContratoId': id });
	};
	
	$scope.newContrato = function(){
		//$scope.closeContracts();
		$state.go('app.new_contrato', { ClienteId: $stateParams.ClienteId });
	};
})

.controller('ContratoCtrl', function($state, $scope, $rootScope, $timeout, $ionicPopup, $ionicModal, $stateParams, Loading, Cliente, Contrato, Vales, Producto, Credito, ApiEndpoint, AuthService){
	
	$scope.$on('$ionicView.enter', function () { 
		$scope.api_url = ApiEndpoint.url;
		$scope.enviroment = localStorage.enviroment;
		$scope.public = localStorage.public;
		$scope.pago_realizado = {"monto" : 0, "condonado" : 0 };
		$scope.today = new Date();
		$scope.todayPlus60 = new Date().setDate($scope.today.getDate()+60);
		if('ContratoId' in $stateParams && $stateParams.ContratoId !== 'new'){
			Loading.show();
			$scope.loadContrato($stateParams.ContratoId).then(function(data){
				Loading.hide();
				$scope.contrato = data.data;
				
				$ionicModal.fromTemplateUrl('templates/restructura.html', {
					scope: $scope,
					backdropClickToClose: false,
					hardwareBackButtonClose: false
				}).then(function(modal) {
					$scope.restructurar = modal;
					$scope.reestructuracion = {
						cliente_id: $scope.contrato.cliente_id,
						padre_id: $scope.contrato.contrato_id,
						precio_acordado: 0,
						periodos: 0,
						interes: 0,
						periodo_entre_pagos: 0,
						numero_pagos: 0
					};
				});
			});
		}else{
			console.log('new Contrato');
			$scope.contrato = {
				contrato_id : 'new',
				cliente_id : $stateParams.ClienteId,
				estado : 'ACTIVO',
				distribuidor_id : null
			};
	
			Producto.all(1).then(function(data){
				if(data.status !== 'ERROR'){
					$scope.Productos = data.data;
					console.log(data);
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			});
		};
	
	});

	$scope.loadContrato = function(id){
		return Contrato.get(id);
	};
	$scope.AuthService = function(p){
		return AuthService.isAuthorized(p);
	}

	$scope.viewCliente = function(id){
		$state.go('app.cliente', { 'ClienteId': id});
	};
	
	$scope.changeProducto = function(){
		console.log('cambio');
		console.log($scope.contrato);
		// debugger
		Loading.show();
		Producto.get($scope.contrato.producto_id).then(function(data){
			// debugger
			if('data' in data){				
				Loading.hide();
				$scope.contrato.interes = data.data.interes
				$scope.contrato.interes_moratorio = data.data.interes_moratorio
				$scope.contrato.dias_de_gracia = data.data.dias_de_gracia
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )

				});
			}
		});
	};

	$scope.changeLote = function(){
		console.log('lote');
		console.log($scope.contrato.lote_id);
	};

	$scope.calcSaldo = function(){
		$scope.contrato.precio_total = parseFloat($scope.contrato.precio_acordado) - parseFloat($scope.contrato.enganche);
	};

	$scope.calcPago = function(){
		console.log($scope.contrato.pago);
		$scope.contrato.pago = Credito.pago($scope.contrato.precio_total, parseFloat($scope.contrato.interes)/360*parseInt($scope.contrato.periodo_entre_pagos), parseInt($scope.contrato.periodos));
		$scope.contrato.saldo_insoluto = $scope.contrato.pago*parseInt($scope.contrato.periodos);
	};
	
	$scope.saveContrato = function(){
		Loading.show();
		
		if($scope.contrato.contrato_id !== 'new'){
			Contrato.update($scope.contrato).then(function(data){
				if('data' in data){				
					Loading.hide();
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Contrato Salvado'
					});
				}else{
					Loading.hide();
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
						
					});
				}
			});
		}else{
			Contrato.nuevo($scope.contrato).then(function(data){
				if('data' in data){
					$scope.contrato.contrato_id = data.data.contrato_id;
					Loading.hide();
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Contrato Salvado'
					});
					$state.go('app.ccontrato', { ClienteId: $scope.contrato.contrato_id});
				}else{
					Loading.hide();
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
						
					});
				}
			});
		}
	};
	
	$ionicModal.fromTemplateUrl('templates/pagar.html', {
		scope: $scope,
		backdropClickToClose: false,
		hardwareBackButtonClose: false
	}).then(function(modal) {
		$scope.modal = modal;
		//$scope.modal.show();
	});

	$scope.restructure = function(c){
		Loading.show();
		$scope.restructurar.show();
		Loading.hide();
	};
	
	$scope.openPago = function(c){
		Loading.show();

		let t = {
			id: c.contrato_id,
			target: 'contrato',
			fecha_programada: c.fecha_programada
		}

		Vales.due(t).then(function(d){
			$scope.pagos = d.data;
			$rootScope.por_pagar = $scope.contrato.cliente;
			$scope.pago = {
				"restante" : ($scope.pagos.pago.capital + $scope.pagos.pago.intereses)*(1-parseFloat($scope.pagos.pago.comision)*0.01) + $scope.pagos.pago.intereses_moratorios + $scope.pagos.pago.seguro,
				"afavor" : 0
			}
			$scope.pago_realizado = {
				"producto_id" : c.producto_id,
				"comision" : parseFloat($scope.pagos.pago.comision),
				"monto" : 0,
				"condonado" : 0,
				"dias_vencidos": c.dias_vencidos,
				"fecha_programada" : c.fecha_programada,
				"fecha_realizada" : new Date()
			};
			if(t.target !== 'contrato') {
				$scope.pago_realizado.distribuidor_id = c.distribuidor_id;
				$scope.pago_realizado.target = 'distribuidor';
			}else{
				$scope.pago_realizado.contrato_id = c.contrato_id;
				$scope.pago_realizado.target = 'contrato';
			}
			$scope.modal.show();
			Loading.hide();
		});
	};

	$scope.closePago = function() {
		$scope.modal.hide();
	};
	
	$scope.closeRestructuracion = function() {
		$scope.restructurar.hide();
	};

	$scope.doRestructura = function(r){
		Contrato.restructure(r).then(function(data){
			if('data' in data){
				//$scope.contrato = data;		
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Listo!',
					template: 'Contrato Cancelado'
				});
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )

				});
			}
		});
	};

	$scope.showConfirm = function() {
		var confirmPopup = $ionicPopup.confirm({
			title: 'Cancelacion de contrato',
			template: 'Estas seguro de cancelar este contrato?'
		});
		
		confirmPopup.then(function(res) {
			if(res) {
				Loading.show();
				Contrato.cancel($scope.contrato.contrato_id).then(function(data){
					if('data' in data){
						$scope.contrato = data;		
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Listo!',
							template: 'Contrato Cancelado'
						});
					}else{
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
	
						});
					}
				});
			} else {
			console.log('You are not sure');
			}
		});
	};

	$scope.cancelContrato = function(){
		if($scope.contrato.contrato_id !== 'new'){
			$scope.showConfirm();
		}
	};

	$scope.get_intereses = function(){
		let intereses = {
			normales: 0,
			moratorios: 0
		};

		if($scope.contrato !== undefined){
			for(pago in $scope.contrato.pagos_detalle){
				if(!$scope.contrato.pagos_detalle[pago].fecha_realizada){
					intereses.normales += $scope.contrato.pagos_detalle[pago].intereses ? parseFloat($scope.contrato.pagos_detalle[pago].intereses) : 0;
					intereses.moratorios += $scope.contrato.pagos_detalle[pago].intereses_moratorios ? parseFloat($scope.contrato.pagos_detalle[pago].intereses_moratorios) : 0;
				}
			}
		}

		return intereses;
	};

	$scope.nuevo_pago = function(){
		if($scope.reestructuracion !== undefined){
			return Credito.pago($scope.reestructuracion.precio_acordado, parseFloat($scope.reestructuracion.interes)*0.01/360*parseInt($scope.reestructuracion.periodo_entre_pagos), parseInt($scope.reestructuracion.periodos));
		}else{
			return 0;
		}
	};

	$scope.autocomplete_cliente = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			onSelectCliente(selected);
        },
		debounce_suggest: 500
	};

	function onSelectCliente(selected) {
		$scope.contrato.cliente_id = selected.item.cliente_id;
		$scope.contrato.cliente =  selected.item;
		$scope.contrato.cliente.saldo_insoluto = 0;
		for(c in  selected.item.contratos){
			if(selected.item.contratos[c].estado == 'ACTIVO'){
				$scope.contrato.cliente.saldo_insoluto  += parseFloat(selected.item.contratos[c].saldo_insoluto);
			}
		}
		$scope.contrato.contratos = $scope.contrato.cliente.contratos;
		console.log($scope.contrato);
	}

	function fuzzy_suggest_cliente(t) {
		if(t == $scope.cliente_temp) return;

		var params = {
			type : 'fullName',
			producto_id : '1,2',
			multiplo : 1000,
			value : t
		};
		var deferred = $q.defer();
		Cliente.search(params, 1).then(function(data){
			if(data.data.length == 0) return;

			clientes = data.data.map(function (i){
				let cliente = i;
				cliente.nombre_completo = i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;

				return cliente;
			});

			var fuzzySearch = new Fuse(data.data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 1,
				keys: ['nombre','nombre_segundo','apellido_paterno','apellido_materno', 'nombre_completo']
			});
			if(data.data.length == 1){
				var busqueda = data.data
					.map(function(i) {
						var val = '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.cliente_id + '</span>' + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno + '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.curp + '</span>';
						// var val = "(" + i.cliente_id + ") " + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;
						return {
							id : i.cliente_id,
							item: i,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}else{

				var busqueda = fuzzySearch.search(t)
					.map(function(i) {
						var val = '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.cliente_id + '</span>' + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno + '<span class="badge ng-binding badge-assertive" ng-class="title badge-assertive">' + i.curp + '</span>';
						// var val = "(" + i.item.cliente_id + ") " + i.item.nombre + " " + i.item.nombre_segundo + " " + i.item.apellido_paterno + " " + i.item.apellido_materno;
						return {
							id : i.item.cliente_id,
							item: i.item,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}
			deferred.resolve(busqueda);
		});

		return deferred.promise;
	};
})

.controller('ValesCtrl', function($state, $scope, $q, $ionicModal, $ionicPopup, Loading, Credito, Contrato, Distribuidor, Cliente, Vales, $window){
	$scope.$on('$ionicView.enter', function () { 
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
		$scope.contratos = {};
		$scope.modal = {};
		$scope.dataVales = {};
		$scope.reporteVales= null;
		$scope.productos = "1,2";
		$scope.query = {
			value: ''
		};
	
		$scope.enviroment = localStorage.enviroment;
		$scope.public = localStorage.public;
		$scope.queryVales();

		//vales_nuevos.html
		$ionicModal.fromTemplateUrl('templates/vales_nuevos.html', {
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modal.vales_nuevos = modal;
			//$scope.modal.show();
		});
	});
	$scope.timer = null

	$scope.queryVales = function(){
		clearTimeout($scope.timer)
		$scope.timer = setTimeout(function() {
			$scope.execVales();
		}, 2000);
	};

	$scope.execVales = function () {
		Loading.show();
		const query =  $scope.query.value;
		Vales.count('all', query).then(function(data){
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		Vales.search('all', $scope.page, query).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.vales = data.data;
				console.log(data);
			}
		});
	}
	
	$scope.loadPage = function(p){
		Vales.count($scope.productos).then(function(data){
			console.log(data);
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		console.log(p);
		if(p===''){ return; };
		Loading.show();
		Vales.search($scope.productos, p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.vales = data.data;
				console.log(data);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});	
	};

	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.queryVales();
		}
	};

	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.queryVales();
		}
	};

	$scope.viewVale = function(id){
		//$scope.closeContracts();
		if(id !== null) {
			$state.go('app.contrato', { 'ContratoId': id });
		}
	};

	$scope.dialogCancel = function(vale) {
		var confirmPopup = $ionicPopup.confirm({
		  title: 'Cancelar Vale',
		  template: 'Quieres Cancelar el vale?'
		});
	 
		confirmPopup.then(function(res) {
		  if(res) {
			console.log('You are sure');
			console.log(vale);
			Loading.show();
			Vales.del(vale).then(function(result) {
				Loading.hide();
				$scope.queryVales();
			})
		  } else {
			console.log('You are not sure');
		  }
		});
	};
	
	$scope.newVales = function(){
		Loading.show();
		$scope.modal.vales_nuevos.show();
		Loading.hide();
	};
	
	$scope.closeVales = function() {
		$scope.modal.vales_nuevos.hide();
		$scope.reporteVales = null;
	};
	$scope.cleanVales = function(){
		$scope.reporteVales = null;
	}

	$scope.autocomplete_distribuidor = {
        suggest: fuzzy_suggest,
        on_select: function(selected) {
			console.log(selected.id);
			$scope.dataVales.distribuidor_id =  selected.id;
        }
	};

	$scope.autocomplete_cliente = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			console.log(selected.id);
			$scope.dataVales.cliente_id =  selected.id;
        }
	};
	$scope.loadProductos = function(p, d) {
		Vales.productos(p, d).then(function(data){
			$scope.dataVales.montos = data.data.montos;
			$scope.dataVales.plazos = data.data.plazos;
		});
	}
	//CREAR VALES
	$scope.crearVales = function() {
		console.log($scope.dataVales);
		Vales.save($scope.dataVales).then(function(data){
			if('data' in data){				
					Loading.hide();
					$scope.urlVales = data.data;
					console.log($scope.urlVales);

					$window.open($scope.urlVales.valera+'?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
					$window.open($scope.urlVales.recibo+'?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Vales Salvados'
					});
					$scope.newUsuario = {};
					$scope.loadPage($scope.page);
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )

				});
			}
		}).catch((data) => {
			Loading.hide();
			$scope.alertPopup = $ionicPopup.alert({
				title: 'Error!',
				template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )

			});
		});
	};

	$scope.getTotal = function(){
		Vales.interes($scope.dataVales).then(function(d){
			try {
				$scope.dataVales.producto_sub = d.data;

				if('value' in $scope.dataVales.monto){
					var monto = $scope.dataVales.monto.monto;
					var plazo =  $scope.dataVales.plazo_pagos.value;
				}else{
					var monto = $scope.dataVales.monto;
					var plazo = $scope.dataVales.plazo_pagos/15;
				}

				$scope.dataVales.pago = Credito.pago(monto,d.data.interes/360*15, plazo);
				$scope.dataVales.total =  $scope.dataVales.pago*(plazo);
				//$scope.pago = $scope.pago/$scope.canje.plazo_pagos/15;
			} catch (e) {
				console.warn(e);
			}
		});
	};
	
	function highlight(str, term) {
		var highlight_regex = new RegExp('(' + term + ')', 'gi');
		return str.replace(highlight_regex, '<span class="highlight">$1</span>');
	};

	function fuzzy_suggest(t) {
		if(t.length <= 3 || t == $scope.cliente_temp) return;

		var params = {
			type : 'fullName',
			producto_id : '1,2',
			multiplo : 1000,
			value : t
		};
		var deferred = $q.defer();
		Distribuidor.search(params, 1).then(function(data){
			if(data.data.length == 0) return;
			var fuzzySearch = new Fuse(data.data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 0.05,
				keys: ['nombre','nombre_segundo','apellido_paterno','apellido_materno']
			});
			if(data.data.length == 1){
				var busqueda = data.data
					.map(function(i) {
						var val = "(" + i.distribuidor_id + ") " + i.nombre + " " + i.nombre_segundo + " " + i.apellido_paterno + " " + i.apellido_materno;
						return {
							id : i.distribuidor_id,
							item: i,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}else{
				var busqueda = fuzzySearch.search(t)
					.map(function(i) {
						var val = "(" + i.item.distribuidor_id + ") " + i.item.nombre + " " + i.item.nombre_segundo + " " + i.item.apellido_paterno + " " + i.item.apellido_materno;
						return {
							id : i.item.distribuidor_id,
							item: i.item,
							value: val,
							label: '<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
						};
					});
			}
			deferred.resolve(busqueda);
		});

		return deferred.promise;
	};

	//HERE CLIENTE
	function fuzzy_suggest_cliente(t) {
		var deferred = $q.defer();
		var params = {
			'type' : 'fullName',
			'value' : t
		};
		
		Cliente.search(params, 1).then(function(d){
			var busqueda = d.data
				.map(function(i) {
					var val = '('+i.cliente_id+') : '+i.rfc+' : '+i.nombre+' '+i.nombre_segundo+''+i.apellido_paterno+' '+i.apellido_materno;
					return {
						item : i,
						value:	i.cliente_id,
						label: '<div class="container-fluid">' +
							'  <div class="pull-left">' +
							highlight(val, t) +
							'  </div>' +
							'</div>'
					};
				});

			deferred.resolve(busqueda);
		});
		return deferred.promise;
	};
})

.controller('ReportedeIngresosCtrl', function( $scope, $state, ReportedeIngresos, ApiEndpoint){
	$scope.$on('$ionicView.enter', function () {
		$scope.ano = 2019;
		$scope.api_url = ApiEndpoint.url;
		$scope.mesShow = [];
		$scope.group = [];
		$scope.group.show = [];
	});
	$scope.queryReportes = function(){
		ReportedeIngresos.time().then(function(data){
			$scope.time = data.data;
			console.log($scope.time);
		});
		
	}
	$scope.setAno= function(value){
		$scope.ano = value;
		console.log($scope.ano);
	};

	$scope.sum_month = function(v, key = 'capital'){
		var sum = 0;
		for(i in v){
			sum += v[i][key];
		}

		return sum;
	};
	$scope.setMesShow = function(i) {
		$scope.mesShow = i;	
		console.log($scope.mesShow);
	}
	$scope.viewFechadeReporte = function(i){
		console.log(i);
		$state.go('app.fechadeReporte', { 'FechadeReporte': i});
	};
	$scope.queryReportes();

	$scope.intereses = function(i){
		return i/1.16;
	};

	$scope.iva = function(i){
		return i/1.16*0.16;
	};
})

.controller('FechadeReporteCtrl', function($scope, $state, ReportedeIngresos, $stateParams){
	$scope.fecha = $stateParams.FechadeReporte;
	$scope.viewCliente = function(i){
		console.log(i);
		$state.go('app.cliente', { 'ClienteId': i});
	};
	$scope.viewContrato = function(i){
		console.log(i);
		$state.go('app.contrato', { 'ContratoId': i});
	};
	
	$scope.queryFechaReportes = function(){
		ReportedeIngresos.fechaReportes($scope.fecha).then(function(data){
			$scope.f= data.data;
			console.log($scope.f);
		});	
		
	}
	$scope.queryFechaReportes();
})

.controller('BitacoraCtrl', function($scope){

})

.controller('BitacorasCtrl', function($scope, $q, Bitacora, Loading, $ionicModal, $rootScope, $ionicPopup){
	
	$scope.$on('$ionicView.enter', function () {
		$scope.modal = {
			bitacora : {},
			bitacora_new : {}
		};
	
		$scope.enviroment = localStorage.enviroment;
		$scope.public = localStorage.public;
		Loading.show();
		$scope.getAll();
	});

	$scope.reporteFechaIDStatus = function(e) {
		var tmplt = 	
						'<label class="item item-input"><select ng-model="data.rol">' +
						'<option value="ALL">Todos</option>' +
						'<option value="ACTIVO">Activos</option>' +
						'<option value="MOROSO">Moroso</option>' +
						'</select></label>' +
						'<label class="item item-input"><i class="icon ion-user placeholder-icon"></i><input type="number" ng-model="data.id" placeholder="ID"></label>' +
						'<label class="item item-input"><i class="icon ion-calendar placeholder-icon"></i><input type="date" format="date" ng-model="fechas.fecha" placeholder="Fecha"></label>';
		console.log("modal");
		$rootScope.data = {
			id: 0
		}
		$ionicPopup.confirm({
			title: 'Definir Fechas',
			template:	tmplt
		}).then(function(res) {
			if(res){
				console.log($scope.fechas);
				$window.open(ApiEndpoint.url + 'reportes/'+e+'/'+$rootScope.data.rol+'/'+$rootScope.data.id+'/'+$filter('date')($rootScope.fechas.fecha, "yyyy-MM-dd")+'/?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public,'_NEW');
			}else{
				console.log($scope.fechas);
			}
		});
	};

	$scope.getAll = function(){
		requests = [
			Bitacora.actives(),
			Bitacora.hoy()
		];
		
		$q.all(requests).then(function(data){
			$scope.bitacoras = data[0].data;
			$scope.hoy = data[1].data;
			Loading.hide();
		});
	};
	
	$scope.viewBitacoras = function(distribuidor){
		Loading.show();

		$ionicModal.fromTemplateUrl('templates/bitacora.html', {
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modal.bitacora = modal;
			$scope.getSRC = function(t,d){
				return 'https://api.avanzamas.net/attachment/distribuidor/'+t+'/'+d.cliente_id.padStart(3, "0")+'?enviroment='+localStorage.enviroment+'&avanzamas-token='+localStorage.public;
			};
		
			$scope.img = {
				'firma': $scope.getSRC('firmas', distribuidor),
				'ine': $scope.getSRC('ines', distribuidor),
				'address': $scope.getSRC('addresses', distribuidor),
				'casas': $scope.getSRC('casas', distribuidor),
				'profiles': $scope.getSRC('profiles', distribuidor)
			};
			requests = [
				Bitacora.cliente(distribuidor.cliente_id),
				Bitacora.distribuidor(distribuidor.cliente_id),
				Bitacora.dedistribuidor(distribuidor.cliente_id)
			];
			$q.all(requests).then(function(data){
				$scope.cliente = data[0];
				$scope.cliente.distribuidor = data[1];
				$scope.cliente.bitacoras = data[2];
				$scope.modal.bitacora.show();
				Loading.hide();
			});	
		});
	};

	$scope.newBitacoras = function(){
		$ionicModal.fromTemplateUrl('templates/bitacora_nueva.html', {
			scope: $scope,
			backdropClickToClose: false,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modal.bitacora_new = modal;
			$scope.modal.bitacora_new.show();
		});
		
	};

	$scope.closeNuevaBitacora = function(){
		$scope.modal.bitacora_new.remove();
	};
	
	$scope.closeBitacora = function() {
		$scope.modal.bitacora.remove();
	};
})

.controller('newBitacoraCtrl', function($scope, $q, Bitacora){
	$scope.$on('$ionicView.enter', function () {
		console.log($scope.cliente);
		$scope.bitacora = {};
		$scope.bitacora = $scope.cliente;
	});

	$scope.save = function(){
		// requests = [
		// 	Bitacora.nuevo($scope.bitacora),
		// 	Bitacora.dedistribuidor($scope.cliente.distribuidor_id)
		// ];
		// $q.all(requests).then(function(data){
		// 	$scope.cliente.bitacoras = data[1];
		// 	$scope.getAll();
		// 	$scope.closeNuevaBitacora();
		// });
		Bitacora.nuevo($scope.bitacora).then(function(data){
			Bitacora.dedistribuidor($scope.cliente.distribuidor_id).then(function(d){
				$scope.cliente.bitacoras = d;
				$scope.getAll();
				$scope.closeNuevaBitacora();
			});
		});
	};
})

.controller('UsuariosCtrl', function($state, $scope, $ionicPopup, Loading, Usuario, Permiso, $ionicModal, $ionicPopup){
	
	$scope.$on('$ionicView.enter', function () { 
		$scope.usuarios = {};
		$scope.usuario = {};
		$scope.newUsuario = {};
		$scope.upUsuario = {};
		$scope.updUsuario = [];
		$scope.accesos = {
			"-1":"Admin",
			"0":"Análisis",
			"1":"Cobranza",
			"2":"Caja"
		};
		$scope.acceso_i = null;
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
	    $scope.loadPage($scope.page);
	});
	
	$scope.loadPage = function(p){
		Usuario.count().then(function(data){
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		if(p===''){ return; };
		Loading.show();
		Usuario.all(p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.usuarios = data.data;
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});	
	};

	//MODAL
	$ionicModal.fromTemplateUrl('templates/nuevoUsuario.html', {
		scope: $scope,
		backdropClickToClose: false,
		hardwareBackButtonClose: false
	}).then(function(modal) {
		$scope.modalNew = modal;
	});

	$ionicModal.fromTemplateUrl('templates/editarUsuario.html', {
		scope: $scope,
		backdropClickToClose: false,
		hardwareBackButtonClose: false
	}).then(function(modal) {
		$scope.modalEdit = modal;
	});

	$scope.closeEditUsuario = function(){
		$scope.modalEdit.hide();
		$scope.usuario = {};
	};

	$scope.closeNewUsuario = function(){
		$scope.modalNew.hide();
	};
	//NEW USER
	$scope.openNew = function(c){
		$scope.modalNew.show();
	};

	$scope.eliminate = function(permiso){
		Permiso.eliminar(permiso).then(function(){
			$scope.openEdit($scope.usuario.usuario_id);
		});
	};

	$scope.showPopup = function() {
		$scope.permiso = {};
		
		// An elaborate, custom popup
		var myPopup = $ionicPopup.show({
			template: '<input type="text" ng-model="permiso.permiso">',
			title: 'Nuevo Permiso',
			subTitle: 'Asigna nuevo Permisso',
			scope: $scope,
			buttons: [
			{ text: 'Cancelar' },
			{
				text: '<b>Salvar</b>',
				type: 'button-positive',
				onTap: function(e) {
				if (!$scope.permiso) {
					//don't allow the user to close unless he enters wifi password
					e.preventDefault();
				} else {
					console.log($scope.permiso)
					$scope.permiso.usuario_id = $scope.usuario.usuario_id;
					Permiso.nuevo($scope.permiso).then(function(){
						$scope.openEdit($scope.usuario.usuario_id);
					});
				}
				}
			}
			]
		});
	};

	$scope.doUser = function(){
		Usuario.save($scope.newUsuario).then(function(data){
			if('data' in data){				
					Loading.hide();
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Usuario Salvado'
					});
					$scope.newUsuario = {};
					$scope.loadPage($scope.page);
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )

				});
			}
		});
	};
	
	//UPLOAD USER

	$scope.openEdit = function(u){
		Usuario.get(u).then(function(data){
			if('data' in data){
				$scope.usuario = data.data;
				console.log($scope.usuario);
				$scope.modalEdit.show();
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});
		// $scope.upUsuario = {};
		// $scope.updUsuario.push({
		// 	user_id : c
		// });
		// console.log($scope.updUsuario);
		
	};

	$scope.upUser = function(u, i){
		Usuario.update(u, i).then(function(data){
			if('data' in data){
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Usuario actualizado'
					});
					$scope.loadPage($scope.page);
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});
	};
})

.controller('ProductosCtrl', function($scope, $timeout, $ionicPopup, Usuario, Loading, Producto, $ionicPopup, $ionicModal) {
	$scope.$on('$ionicView.enter', function () { 
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
		$scope.productos = {};
		$scope.producto = {};
		$scope.newProducto = {};
		$scope.updProducto = {};
		$scope.query = {
			type : 'nombre',
			value : ''
		};

	    $scope.loadPage($scope.page);
	});

	$scope.loadPage = function(p){
		Producto.count().then(function(data){
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		console.log(p);
		if(p===''){ return; };
		Loading.show();
		Producto.all(p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.productos = data.data;
			}else{
				Usuario.openLogin();
			}
		});	
	};

	//MODAL
	$ionicModal.fromTemplateUrl('templates/nuevoProducto.html', {
		scope: $scope,
		backdropClickToClose: false,
		hardwareBackButtonClose: false
	}).then(function(modal) {
		$scope.modalNew = modal;
	});

	$ionicModal.fromTemplateUrl('templates/editarProducto.html', {
		scope: $scope,
		backdropClickToClose: false,
		hardwareBackButtonClose: false
	}).then(function(modal) {
		$scope.modalEdit = modal;
	});

	$scope.closeEdit = function(){
		$scope.modalEdit.hide();
	};

	$scope.closeNew = function(){
		$scope.modalNew.hide();
	};
	//NEW PRODUCTO
	$scope.openNew = function(c){
		$scope.modalNew.show();
	};

	$scope.doProd = function(){
		console.log($scope.newProducto);
		Producto.save($scope.newProducto).then(function(data){
			if('data' in data){				
					Loading.hide();
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Producto Salvado'
					});
					$scope.newProducto = {};
					$scope.loadPage($scope.page);
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )

				});
			}
		});
	};
	
	//UPLOAD PRODUCTO
	$scope.openEdit = function(p){
		Loading.show();
		Producto.get(p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.producto = data.data;
				console.log($scope.producto);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});
		$scope.modalEdit.show();
	};

	$scope.upProd = function(p){
		console.log(p);
		Producto.update(p).then(function(data){
			if('data' in data){
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Listo!',
						template: 'Producto actualizado'						
					});
					$scope.loadPage($scope.page);
			}else{
				Loading.hide();
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});
	};
	
	$scope.queryPoyecto = function(){
		$timeout(function() {
			$scope.page = 1;
			Loading.show();
			producto.search($scope.query, $scope.page).then(function(data){
				Loading.hide();
				if(data.status !== 'ERROR'){
					$scope.Productos = data.data;
					console.log(data);
				}else{
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});
				}
			})
			, 3000
		});
	};
	
	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.loadPage($scope.page);
		}
	};

	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.loadPage($scope.page);
		}
	};
})

.controller('SolicitudesCtrl', function($q, $scope, $state, $stateParams, Loading, Solicitudes ){
	$scope.$on('$ionicView.enter', function () { 
		$scope.page = typeof $scope.page == 'undefined' ? 1 : $scope.page;
		$scope.solicitudes = {};
		$scope.solicitud= {};
	    $scope.loadPage($scope.page);
	});

	$scope.verificarCancelado = function(s){
		return s.cancelado_date ? 'cancelado' : '';
	};

	$scope.loadPage = function(p){
		Solicitudes.count().then(function(data){
			$scope.totales = Math.ceil(parseInt(data.data.total)/50);
		});
		Loading.show();
		Solicitudes.getSolicitudes(p).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.solicitudes = data.data;
				console.log($scope.solicitudes);
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});
	};

	$scope.newSolicitud = function(){
		$state.go('app.solicitud_new');
	};

	$scope.goSolicitud = function(s){
		$state.go('app.solicitud', { 'SolicitudId': s});
	};
	
	$scope.goAnalisis = function(s){
		$state.go('app.analisis', { 'SolicitudId': s});
	};

	$scope.goDispercion = function(s){
		$state.go('app.disperciones', { 'SolicitudId': s});
	};

	$scope.nextPage = function(){
		if($scope.page < $scope.totales){
			$scope.page += 1;
			$scope.loadPage($scope.page);
		}
	};

	$scope.prevPage = function(){
		if($scope.page > 1){
			$scope.page -= 1;
			$scope.loadPage($scope.page);
		}
	};
})

.controller('SolicitudNewCtrl', function($q, $scope, $state, $filter, $ionicPopup, Loading, Cliente, Producto, Distribuidor, Domicilio, Telefono, Solicitudes){
	$scope.$on('$ionicView.enter', function () { 
		$scope.solicitud = {
			laboral_sueldo_neto: 0,
			laboral_deducciones: 0,
			laboral_ingresos: 0
		};
	});
	
	$scope.autocomplete_cliente = {
        suggest: fuzzy_suggest_cliente,
        on_select: function(selected) {
			console.log(selected);
			$scope.solicitud.cliente_id = selected.item.cliente_id;
			$scope.solicitud.cliente = selected.item;
			$scope.get_clienteInfo($scope.solicitud.cliente_id);
        }
	};

	$scope.get_clienteInfo = function(c){
		Loading.show();

		requests = [
			Domicilio.all(c),
			Telefono.all(c)
		];
		
		$q.all(requests).then(function(data){
			$scope.solicitud.cliente.domicilio = data[0].data[0];
			$scope.solicitud.cliente.telefono = data[1].data[0];
			Loading.hide();
		});
	};

	$scope.autocomplete_producto = {
        suggest: fuzzy_suggest_producto,
        on_select: function(selected) {
			console.log(selected);
			$scope.solicitud.producto = selected.item;
			$scope.solicitud.producto_id = selected.item.producto_id;
        }
	};

	$scope.autocomplete_distribuidor = {
        suggest: fuzzy_suggest_distribuidor,
        on_select: function(selected) {
			console.log(selected);
			$scope.solicitud.distribuidor = selected.item;
			$scope.solicitud.distribuidor_id = selected.item.distribuidor_id;
        }
	};
	
	function highlight(str, term) {
		var highlight_regex = new RegExp('(' + term + ')', 'gi');
		return str.replace(highlight_regex, '<span class="highlight">$1</span>');
	};

	function fuzzy_suggest_cliente(t) {
		var deferred = $q.defer();
		var params = {
			'type' : 'fullName',
			'value' : t
		};
		
		Cliente.search(params, 1).then(function(d){
			var busqueda = d.data
				.map(function(i) {
					var val = '('+i.cliente_id+') : '+i.rfc+' : '+i.nombre+' '+i.nombre_segundo+''+i.apellido_paterno+' '+i.apellido_materno;
					return {
						item : i,
						value:	i.cliente_id,
						label: '<div class="container-fluid">' +
							'  <div class="pull-left">' +
							highlight(val, t) +
							'  </div>' +
							'</div>'
					};
				});

			deferred.resolve(busqueda);
		});
		return deferred.promise;
	};

	function fuzzy_suggest_producto(t) {
		var deferred = $q.defer();
		var params = {
			'type' : 'fullName',
			'value' : t
		};

		Producto.search(params, 1).then(function(d){
			
			var fuzzySearch = new Fuse(d.data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 0.6,
				keys: ['nombre']
			});
	
			var busqueda = fuzzySearch.search(t)
				.map(function(i) {
					var val = '('+i.item.producto_id+') : '+i.item.nombre;
					return {
						item : i.item,
						value:	i.item.nombre,
						label: '<div class="container-fluid">' +
							'  <div class="pull-left">' +
							highlight(val, t) +
							'  </div>' +
							'</div>'
					};
				});

			deferred.resolve(busqueda);
		});
		return deferred.promise;
	};

	function fuzzy_suggest_distribuidor(t) {
		var deferred = $q.defer();
		var params = {
			'producto_id' : $scope.solicitud.producto_id,
			'type' : 'fullName',
			'value' : t
		};

		Distribuidor.search(params, 1).then(function(d){
			
			var fuzzySearch = new Fuse(d.data, {
				shouldSort: true,
				includeScore: true,
				caseSensitive: false,
				id: false,
				threshold: 0.05,
				keys: ['nombre','nombre_segundo','apellido_paterno','apellido_materno']
			});
	
			var busqueda = fuzzySearch.search(t)
				.map(function(i) {
					var val = '('+i.item.distribuidor_id+') : '+i.item.nombre+' '+i.item.nombre_segundo+''+i.item.apellido_paterno+' '+i.item.apellido_materno;
					return {
						item :	i.item,
						value:	i.item.nombre,
						label:	'<div class="container-fluid">' +
								'  <div class="pull-left">' +
								highlight(val, t) +
								'  </div>' +
								'</div>'
					};
				});

			deferred.resolve(busqueda);
		});
		return deferred.promise;
	};

	$scope.updSolicitud = function(s){

		var confirmPopup = $ionicPopup.confirm({
			title: 'Nueva Solicitud',
			template: 'Desas crear esta solicitud?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				Solicitudes.save(s).then(function(data){
					if('data' in data){				
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Listo!',
							template: 'Solicitud Guardada'
						});

						$state.go('app.solicitud',{SolicitudId :  data.data.solicitud_id })
					}else{
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
						});
					}
				});

			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.calcSueldo = function(){
		$scope.solicitud.laboral_sueldo_bruto = parseFloat($scope.solicitud.laboral_sueldo_neto) - parseFloat($scope.solicitud.laboral_deducciones) + parseFloat($scope.solicitud.laboral_ingresos);
	};

})

.controller('SolicitudCtrl', function($q, $scope,  $state, $filter, $ionicPopup, $stateParams, Loading, Solicitudes ){
	$scope.$on('$ionicView.enter', function () { 
		$scope.solicitud= {};
		$scope.solicitud = {};
		$scope.dateAsString  = "";
		$scope.solicitudUpdate= {};
		$scope.antiguedadDate = {};
	    $scope.getSolicitud();
	});
	
	$scope.getSolicitud = function(){
		Solicitudes.getSolicitud($stateParams.SolicitudId).then(function(data){
			Loading.hide();
			if(data.status !== 'ERROR'){
				$scope.solicitud = data.data;
				//$scope.solicitud.laboral_antiguedad_date = $filter('date')($scope.solicitud.laboral_antiguedad_date, "yyyy-MM-dd");
				console.log($scope.solicitud.laboral_antiguedad_date);
				console.log(new Date().getTimezoneOffset());
				//$scope.solicitud.laboral_antiguedad_date = new Date((new Date($scope.solicitud.laboral_antiguedad_date).getTime()) + (new Date().getTimezoneOffset()*60000)+3600000);
				console.log($scope.solicitud.laboral_antiguedad_date);
				
			}else{
				$scope.alertPopup = $ionicPopup.alert({
					title: 'Error!',
					template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
				});
			}
		});
	}
	//$scope.item.dateAsString = $filter('dateToISO')($scope.solicitud.laboral_contrato, "yyyy-MM-dd");
	$scope.cancelSolicitud = function(){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Cancelar Solicitud',
			template: '¿Estas Seguro que quieres cancelar la solicitud?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				console.log('You are sure');
				Solicitudes.cancelSolicitud($stateParams.SolicitudId).then(function(data){
					if(typeof data !== 'undefined'){
						console.log(data);
						$scope.getSolicitud();
					}else{
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
						});
					}
				});
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.copSolicitud = function(){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Copiar Solicitud',
			template: 'Desas copiar esta solicitud?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				$scope.solicitud.solicitud_id = null;
				console.log($scope.solicitud)
				Solicitudes.save($scope.solicitud).then(function(data){
				if('data' in data){
						Loading.hide();
						$state.go('app.solicitud', {SolicitudId : data.data.solicitud_id});
				}else{
					Loading.hide();
					$scope.alertPopup = $ionicPopup.alert({
						title: 'Error!',
						template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
					});	
				}
			});
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.updSolicitud = function(s){
		$scope.solicitud.laboral_antiguedad_date = $filter('date')($scope.solicitud.laboral_antiguedad_date, "yyyy-MM-dd");
		$scope.solicitudUpd = $scope.solicitud;
		console.log($scope.solicitudUpd);

		var confirmPopup = $ionicPopup.confirm({
			title: 'Copiar Solicitud',
			template: 'Desas actualizar esta solicitud?'
		});
		confirmPopup.then(function(res) {
			if(res) {
				Solicitudes.update($stateParams.SolicitudId, $scope.solicitudUpd).then(function(data){
					if('data' in data){				
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Listo!',
							template: 'Solicitud Actualizada'
						});
					}else{
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
						});
					}
				});
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.analizarSolicitud = function(){
		$state.go('app.analisis', {SolicitudId : $stateParams.SolicitudId});
	};
})

.controller('SolicitudAnalisisCtrl', function($scope, $stateParams, $ionicPopup, Loading, Solicitudes, Credito ){
	$scope.solicitud= {};

	$scope.get_semanas = function(i){
		return parseInt(i);
	};

	$scope.get_sueldoNeto = function(i){
		return parseFloat(i.laboral_sueldo_bruto)-parseFloat(i.laboral_deducciones)+parseFloat(i.laboral_ingresos);
	};

	$scope.rechazar = function(){
		var confirmPopup = $ionicPopup.prompt({
			title: 'Rechazar Solicitud',
			template: 'Estas seguro de rechazar esta solicitud?',
			inputType: 'text',
		});
		
		confirmPopup.then(function(res) {
			if(res) {
				Loading.show();
				Solicitudes.solicitudRechazar($scope.solicitud, res).then(function(data){
					if('data' in data){
						$scope.solicitud = data.data;
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Listo!',
							template: 'Solicitud Rechazada'
						});
					}else{
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
						});
					}
				});
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.analizar = function(){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Analizar Solicitud',
			template: 'Estas seguro de anlizar esta solicitud?',
		});
		
		confirmPopup.then(function(res) {
			if(res) {
				Loading.show();
				Solicitudes.solicitudAnalizar($scope.solicitud).then(function(data){
					if('data' in data){
						$scope.solicitud = data.data;		
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Listo!',
							template: 'Solicitud Analizada'
						});
					}else{
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
	
						});
					}
				});
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.aprovar = function(){
		var confirmPopup = $ionicPopup.confirm({
			title: 'Aprovar Solicitud',
			template: 'Estas seguro de aprovar esta solicitud?',
		});
		
		confirmPopup.then(function(res) {
			if(res) {
				Loading.show();
				Solicitudes.solicitudAprovar($scope.solicitud).then(function(data){
					if('data' in data){
						$scope.solicitud = data.data;		
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Listo!',
							template: 'Solicitud Aprovada'
						});
					}else{
						Loading.hide();
						$scope.alertPopup = $ionicPopup.alert({
							title: 'Error!',
							template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
	
						});
					}
				});
			} else {
				console.log('You are not sure');
			}
		});
	};

	$scope.get_namePeriodo = function(p){
		var nombre = "";
		p = parseInt(p);
		switch(p){
			case 7:
				nombre = "semanal";
			break;
			case 15:
				nombre = "quincenal";
			break;
			case 30:
				nombre = "mensual";
			break;
		}

		return nombre;
	};

	Solicitudes.getSolicitud($stateParams.SolicitudId).then(function(data){
		Loading.hide();
		if(data.status !== 'ERROR'){
			$scope.solicitud = data.data;
			$scope.calcular_solicitud();
		}else{
			$scope.alertPopup = $ionicPopup.alert({
				title: 'Error!',
				template: data.status === 'ERROR' ? data.msg : ( Array.isArray(data) ? data.join() : data )
			});
		}
	});

	$scope.calcular_solicitud = function(){
		var periodos = [6, 12, 18, 24, 36];
				
		$scope.pagos = {
			quincenal : {},
			semanal : {},
			mensual : {}
		};
		
		for(j=0; j <= periodos.length-1; j++){
			var value = $scope.solicitud.credito_autorizado ? parseFloat($scope.solicitud.credito_autorizado) : ( $scope.solicitud.credito_sugerido ? parseFloat($scope.solicitud.credito_sugerido) : parseFloat($scope.solicitud.credito_monto));
			var i = parseFloat($scope.solicitud.producto.interes)-1;

			$scope.pagos.semanal[periodos[j]] = parseInt(Credito.pago(value, i/360*7, Math.round(periodos[j]*4)));
			$scope.pagos.quincenal[periodos[j]] = parseInt(Credito.pago(value, i/360*15, periodos[j]*2));
			$scope.pagos.mensual[periodos[j]] = parseInt(Credito.pago(value, i/360*30, periodos[j]));
		};
	};
});